=== added file '.bzrignore'
--- .bzrignore	1970-01-01 00:00:00 +0000
+++ .bzrignore	2007-01-14 05:43:15 +0000
@@ -0,0 +1,5 @@
+./dist
+./loggerhead.egg-info
+./loggerhead.conf
+./loggerhead.pid
+./logs

=== added file 'MANIFEST.in'
--- MANIFEST.in	1970-01-01 00:00:00 +0000
+++ MANIFEST.in	2006-12-24 06:43:14 +0000
@@ -0,0 +1,4 @@
+include dev.cfg loggerhead.conf
+recursive-include loggerhead/templates *.kid
+recursive-include loggerhead/config *.cfg
+recursive-include loggerhead/static *

=== added file 'Makefile'
--- Makefile	1970-01-01 00:00:00 +0000
+++ Makefile	2006-12-24 06:43:14 +0000
@@ -0,0 +1,9 @@
+
+PYTHON ?= python
+
+dist:
+	$(PYTHON) ./setup.py sdist
+
+clean:
+	rm -rf dist/
+

=== added file 'NEWS'
--- NEWS	1970-01-01 00:00:00 +0000
+++ NEWS	2007-01-24 19:29:58 +0000
@@ -0,0 +1,48 @@
+
+What's changed in loggerhead?
+=============================
+
+1.1.1  [24jan2006]
+------------------
+
+    - fix broken inventory page (oops!)
+    
+    - fix a few rendering problems with kid and safari
+
+
+1.1  [20jan2006]
+----------------
+
+    - new feature to compare two revisions to each other
+    
+    - inserted text in diffs is now blue instead of green
+    
+    - fixed to start and stop as a daemon now (use "-f" to run in the
+      foreground), and all config is in loggerhead.conf (no need to mess with
+      dev.cfg)
+      
+    - renamed show/hide javascript buttons to expand/collapse, and made them
+      much faster
+      
+    - added an atom-feed link to each branch on the browse page [elliot
+      murphy]
+      
+    - auto-publish feature for multiple branches under a single folder (see
+      loggerhead.conf.example)
+      
+    - added the ability to share cache files per-project instead of just
+      per-branch
+    
+    - added side-by-side diff display for the revision page (which is the
+      default), with a button to switch between side-by-side and unified diff
+      format
+
+    - made caching use file locking, and close cleanly on shutdown
+    
+    - miscellaneous speed and page-size improvements
+
+
+1.0  [23dec2006]
+----------------
+
+    - initial release

=== modified file 'README.txt'
--- README.txt	2006-12-11 06:44:19 +0000
+++ README.txt	2007-01-24 19:29:58 +0000
@@ -1,4 +1,64 @@
-loggerhead
-
-This is a TurboGears (http://www.turbogears.org) project. It can be
-started by running the start-loggerhead.py script.
\ No newline at end of file
+LOGGERHEAD
+==========
+
+[ version 1.1.1 for bazaar 0.13 ]
+
+Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
+a branch history, annotate files, perform searches... all the usual things.
+
+This is a TurboGears (http://www.turbogears.org) project.  It can be
+started by running::
+
+    $ ./start-loggerhead.py
+    
+This will run loggerhead in the background.  To stop it, run::
+
+    $ ./stop-loggerhead.py
+
+If you're not familiar with TurboGears, the simplest way to get running is
+to add the following lines to your apache configuration::
+
+    <Location "/branches/">
+        ProxyPass http://127.0.0.1:8080/
+        ProxyPassReverse http://127.0.0.1:8080/
+    </Location>
+    
+The config file is "loggerhead.conf".  In there, you can configure projects,
+and branches per project.  The idea is that you could be publishing several
+(possibly unrelated) projects through the same loggerhead instance, and 
+several branches for the same project.
+
+Don't bother with "dev.cfg" or any of the other TurboGears config files.
+Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder.
+
+
+CACHES
+------
+
+To speed up most operations, loggerhead will start creating two caches per
+branch when it first launches:
+
+    - a revision data cache
+    - a text searching cache
+
+You can put the cache folder anywhere, but I find that a folder under
+the branch's .bzr/ folder is the simplest place.
+
+The caches for a branch with 10,000 revisions take about 15 minutes each
+on my machine, but YMMV.  Once they are built, they update every six hours
+or so but usually finish quickly (or instantly) after the initial creation.
+Until the revision cache is built, all operations will be slow.
+
+You may update the bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and bazaar uses its own branch locking
+to prevent corruption.
+
+
+SUPPORT
+-------
+
+This is loosely based on bazaar-webserve, which was loosely based on hgweb.
+Discussion should take place on the bazaar-dev mailing list.
+

=== modified file 'dev.cfg'
--- dev.cfg	2006-12-15 09:20:04 +0000
+++ dev.cfg	2007-01-14 05:40:40 +0000
@@ -55,18 +55,18 @@
 [[loggers]]
 [[[loggerhead]]]
 level='DEBUG'
-qualname='loggerhead'
-handlers=['debug_out']
+#qualname='loggerhead'
+#handlers=['debug_out']
 
-[[[allinfo]]]
-level='INFO'
-handlers=['debug_out']
+#[[[allinfo]]]
+#level='INFO'
+#handlers=['debug_out']
 
 [[[access]]]
 level='INFO'
 qualname='turbogears.access'
-handlers=['access_out']
-propagate=0
+#handlers=['access_out']
+#propagate=0
 
 
 

=== added directory 'homepage'
=== added directory 'homepage/download'
=== added file 'homepage/download/loggerhead-1.0-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.0-0.13.tar.gz and homepage/download/loggerhead-1.0-0.13.tar.gz differ
=== added file 'homepage/index.html'
--- homepage/index.html	1970-01-01 00:00:00 +0000
+++ homepage/index.html	2007-01-24 18:45:06 +0000
@@ -0,0 +1,60 @@
+<html>
+<head>
+    <style type="text/css">
+@import "loggerhead.css";
+    </style>
+</head>
+<body>
+    <img src="loggerhead-logo-medium.png" />
+    
+    <p>
+    Loggerhead is a web viewer for projects in
+    <a href="http://www.bazaar-vcs.org/">bazaar</a>.
+    It can be used to navigate
+    a branch history, annotate files, view patches, perform searches, etc.
+    It's heavily based on 
+    <a href="https://launchpad.net/products/bzr-webserve">bazaar-webserve</a>,
+    which is itself based on
+    <a href="http://www.selenic.com/mercurial/wiki/index.cgi">hgweb</a> for
+    Mercurial.  The primary difference is that loggerhead is built on top of
+    <a href="http://www.turbogears.org/">TurboGears</a>.
+    </p>
+    
+    <p>
+    Loggerhead is released under the GPL license, and is written entirely
+    in python 2.4.
+    </p>
+    
+    <h2> Download </h2>
+    
+    <p>
+    The current version is 1.1-0.13 (meaning 1.1, based on bazaar 0.13),
+    released on 20 Jan 2006 at revision 98.
+    </p>
+    <ul class="downloads">
+    <li> <a href="download/loggerhead-1.1-0.13.tar.gz"> loggerhead-1.1-0.13.tar.gz </a>
+        <br /> <span class="md5"> MD5: 26194d00c72dbcaf63d14d9d099ee91e </span>
+        </li>
+    <li> <a href="download/loggerhead-1.0-0.13.tar.gz"> loggerhead-1.0-0.13.tar.gz </a>
+        <br /> <span class="md5"> MD5: 1b68c1dc6e13f9ed8f2b3ff0267cd8d9 </span>
+        </li>
+    </ul>
+    
+    <h2> Development </h2>
+    
+    <ul>
+    <li> project page on launchpad (for bug reports): <br />
+    <a class="link" href="https://launchpad.net/products/loggerhead/"> https://launchpad.net/products/loggerhead/ </a>
+    </li>
+
+    <li> development branch in bazaar: <br />
+    <a class="link" href="http://www.lag.net/robey/code/loggerhead/"> http://www.lag.net/robey/code/loggerhead/ </a>
+    </li>
+
+    <li> browse the source in loggerview: <br />
+    <a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
+    </li>
+    </ul>	
+    
+</body>
+</html>

=== added file 'homepage/loggerhead-background.png'
Binary files homepage/loggerhead-background.png and homepage/loggerhead-background.png differ
=== added file 'homepage/loggerhead-logo-medium.png'
Binary files homepage/loggerhead-logo-medium.png and homepage/loggerhead-logo-medium.png differ
=== added file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	1970-01-01 00:00:00 +0000
+++ homepage/loggerhead.css	2006-12-24 06:54:21 +0000
@@ -0,0 +1,44 @@
+body {
+    background: url("loggerhead-background.png"); 
+    margin: 0px;
+    font-family: "Lucida Grande", Helvetica;
+    line-height: 1.4em;
+}
+img {
+    border: none;
+}
+p,ul {
+    margin-left: 2em;
+    width: 70%;
+}
+
+a {
+    text-decoration: none;
+    color: #204c90;
+}
+a:hover {
+    text-decoration: underline;
+}
+
+h2 {
+    font-size: 100%;
+    margin-left: 2em;
+    margin-right: 2em;
+    margin-top: 1.5em;
+    border-bottom: solid 1px black;
+}
+
+ul {
+    list-style: url(sphere.png);
+}
+ul.downloads .md5 {
+    font-family: monospace;
+    margin-left: 2em;
+}
+li {
+	margin-bottom: 1em;
+}
+
+.link {
+	margin-left: 1em;
+}

=== added file 'homepage/sphere.png'
Binary files homepage/sphere.png and homepage/sphere.png differ
=== renamed file 'loggerhead.conf' => 'loggerhead.conf.example'
--- loggerhead.conf	2006-12-15 09:20:04 +0000
+++ loggerhead.conf.example	2007-01-14 05:40:40 +0000
@@ -1,16 +1,70 @@
 
-# where is the bazaar branch located, and what should we call it?
-folder='/Users/robey/code/bzr/bzr.dev'
-branch_name='bzr.dev'
-
-# should we cache revisions?  (HIGHLY recommended)  where?
-# this will be a folder containing a couple of files.  if the folder
-# doesn't already exist, we'll create it.
-cachepath='/Users/robey/code/bzr/bzr.dev/.bzr/loggerhead-cache'
-
-# what url should i use in the atom feed, for external sites?
-external_url="http://localhost:8080"
+# use this to change the server's port
+#server.socket_port = 8080
+
+# use this if you're mapping loggerhead within apache via proxy
+#server.webpath = 'http://example.com/branches'
 
 # where's bzrlib?
-bzrpath='/Users/robey/code/bzr/bzr'
-
+# (you only need this if you don't install bzr.)
+#bzrpath = '/Users/robey/code/bzr/bzr'
+
+# if you want a special title on the front page, set it here:
+title = 'branches in loggerhead'
+
+# group branches by project:
+[bazaar]
+
+    # name of this project
+    name = 'bazaar'
+    
+    # for the top browsing page, you can include a description, in raw HTML.
+    #description = 'Bazaar is a <i>revision control system</i>.'
+
+    # should we cache revisions and build a text index?  (HIGHLY recommended)
+    # this will be a folder containing a few files.  if the folder doesn't
+    # exist, it'll be created.
+    #
+    # all branches in this project will share the same cache, which is usually
+    # what you want if they share a repository.  if not, you can also specify
+    # this per-branch.
+    cachepath = '/Users/robey/code/bzr/.bzr/loggerhead-files'
+
+    # each branch is in a sub-folder of the website, and the config
+    # key describes that folder name:
+    [[bzr.dev]]
+
+        # where is the bazaar branch located?
+        folder = '/Users/robey/code/bzr/bzr.dev'
+
+        # (optional) is there a friendier name for the branch that i should
+        # use on the web pages?
+        # you can also define this using the branch's nickname.
+        #branch_name = 'bazaar-dev'
+
+        # (optional) short description for the top-level page
+        # you can also define this using the "description" config key in the
+        # branch's 'branch.conf'.
+        description = "bazaar vcs development branch"
+
+        # (optional) public branch url for the top-level page
+        # you can also define this using the "public_url" config key in the
+        # branch's 'branch.conf'.
+        url = 'http://bazaar-ng.org/bzr/bzr.dev'
+
+
+# here's an example of an auto-published folder:
+[paramiko]
+    name = 'paramiko'
+    cachepath = '/Users/robey/code/paramiko/.bzr/loggerhead-files'
+    
+    # if an auto_publish_folder is given, any bazaar branches discovered in
+    # that folder will be published.  using each branch's 'branch.conf' to
+    # provide optional descriptions and public urls is a nice way to avoid
+    # having to do much configuration here.
+    auto_publish_folder = '/Users/robey/code/paramiko'
+    
+    # if all of the branches under an auto_publish_folder are exported to
+    # the same (base) public url, you can specify that url prefix here, and
+    # each discovered branch's public url will be generated.
+    url_prefix = 'http://www.example.com/code/paramiko'

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2006-12-15 09:20:04 +0000
+++ loggerhead/TODO	2007-01-21 02:46:53 +0000
@@ -1,19 +1,16 @@
 
-* config file
-
-* maybe put this at the footer of each page:
-    paramiko-dev, 419 revisions, 1133 days old
-    first revision: Tue 2003-11-04 08:34:24 +0000
-    latest revision: Sat 2006-12-02 18:33:34 -0800
-    ...or somewhere.
-    ... does this really matter?
-
-* add back the search bar.
-    -- should notice dotted-revnos and use that to jump.
-	-- also search by date should be simple.
-
 * problem: given a folder, find all revisions where items inside that
   folder have changed.
     -- stumper.  maybe ask on bazaar-dev ML?
-
-	
\ No newline at end of file
+    -- aaron bentley says this is a general problem.
+
+* potentially do a 'bzr pull' on a branch on an interval timer
+
+* maybe change "changes" to "history"?  -- asked on bazaar-dev@ for opinions.
+    -- nobody seems to care.
+
+* browse view: sort by name, last change?
+
+* something is leaking on www.lag.net/branches
+
+* download tar archive of revision?

=== added file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	1970-01-01 00:00:00 +0000
+++ loggerhead/branchview.py	2007-01-16 03:52:29 +0000
@@ -0,0 +1,168 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+"""
+collection of configuration and objects related to a bazaar branch.
+"""
+
+import logging
+import posixpath
+import threading
+
+import turbogears
+from cherrypy import HTTPRedirect
+
+from loggerhead import util
+from loggerhead.changecache import ChangeCache
+from loggerhead.history import History
+from loggerhead.textindex import TextIndex
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.atom_ui import AtomUI
+from loggerhead.controllers.revision_ui import RevisionUI
+from loggerhead.controllers.inventory_ui import InventoryUI
+from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.download_ui import DownloadUI
+from loggerhead.controllers.bundle_ui import BundleUI
+
+
+with_history_lock = util.with_lock('_history_lock', 'History')
+
+
+class BranchView (object):
+    def __init__(self, group_name, name, subfolder, absfolder, config, project_config):
+        self._group_name = group_name
+        self._name = name
+        self._folder = subfolder
+        self._absfolder = absfolder
+        self._config = config
+        self._project_config = project_config
+        self.log = logging.getLogger('loggerhead.%s' % (name,))
+        
+        # branch history
+        self._history_lock = threading.RLock()
+        self._history = None
+        self._closed = False
+        
+        self.changes = ChangeLogUI(self)
+        self.revision = RevisionUI(self)
+        self.files = InventoryUI(self)
+        self.annotate = AnnotateUI(self)
+        self.download = DownloadUI(self)
+        self.atom = AtomUI(self)
+        self.bundle = BundleUI(self)
+        
+        # force history object to be loaded:
+        self.get_history()
+        
+        turbogears.startup.call_on_shutdown.append(self.close)
+    
+    @with_history_lock
+    def close(self):
+        # it's important that we cleanly detach the history, so the cache
+        # files can be closed correctly and hopefully remain uncorrupted.
+        # this should also stop any ongoing indexing.
+        self._history.detach()
+        self._history = None
+        self._closed = True
+            
+    config = property(lambda self: self._config)
+    
+    name = property(lambda self: self._name)
+
+    group_name = property(lambda self: self._group_name)
+    
+    def _get_friendly_name(self):
+        name = self._config.get('branch_name', None)
+        if name is not None:
+            return name
+        # try branch-specific config?
+        name = self.get_history().get_config().get_nickname()
+        if name is not None:
+            return name
+        return self._name
+
+    friendly_name = property(_get_friendly_name)
+
+    def _get_description(self):
+        description = self._config.get('description', None)
+        if description is not None:
+            return description
+        # try branch-specific config?
+        description = self.get_history().get_config().get_user_option('description')
+        return description
+        
+    description = property(_get_description)
+    
+    def _get_branch_url(self):
+        url = self._config.get('url', None)
+        if url is not None:
+            return url
+        # try to assemble one from the project, if an url_prefix was defined.
+        url = self._project_config.get('url_prefix', None)
+        if url is not None:
+            return posixpath.join(url, self._folder) + '/'
+        # try branch-specific config?
+        url = self.get_history().get_config().get_user_option('public_branch')
+        return url
+        
+    branch_url = property(_get_branch_url)
+    
+    @turbogears.expose()
+    def index(self):
+        raise HTTPRedirect(self.url('/changes'))
+
+    @with_history_lock
+    def get_history(self):
+        """
+        get an up-to-date History object, safely.  each page-view calls this
+        method, and normally it will get the same History object as on previous
+        calls.  but if the bazaar branch on-disk has been updated since this
+        History was created, a new object will be created and returned.
+        """
+        if self._closed:
+            return None
+        if (self._history is None) or self._history.out_of_date():
+            self.log.debug('Reload branch history...')
+            if self._history is not None:
+                self._history.detach()
+            self._history = History.from_folder(self._absfolder, self._name)
+            cache_path = self._config.get('cachepath', None)
+            if cache_path is None:
+                # try the project config
+                cache_path = self._project_config.get('cachepath', None)
+            if cache_path is not None:
+                self._history.use_cache(ChangeCache(self._history, cache_path))
+                self._history.use_search_index(TextIndex(self._history, cache_path))
+        return self._history
+    
+    def check_rebuild(self):
+        h = self.get_history()
+        if h is not None:
+            h.check_rebuild()
+    
+    def url(self, elements, **kw):
+        if not isinstance(elements, list):
+            elements = [elements]
+        if elements[0].startswith('/'):
+            elements[0] = elements[0][1:]
+        return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
+
+    def last_updated(self):
+        h = self.get_history()
+        change = h.get_changes([ h.last_revid ])[0]
+        return change.date

=== added file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	1970-01-01 00:00:00 +0000
+++ loggerhead/changecache.py	2007-01-08 00:00:26 +0000
@@ -0,0 +1,176 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+"""
+a cache for chewed-up "change" data structures, which are basically just a
+different way of storing a revision.  the cache improves lookup times 10x
+over bazaar's xml revision structure, though, so currently still worth doing.
+
+once a revision is committed in bazaar, it never changes, so once we have
+cached a change, it's good forever.
+"""
+
+import logging
+import os
+import shelve
+import threading
+import time
+
+from loggerhead import util
+from loggerhead.util import decorator
+from loggerhead.lockfile import LockFile
+
+
+with_lock = util.with_lock('_lock', 'ChangeCache')
+        
+
+class ChangeCache (object):
+    
+    def __init__(self, history, cache_path):
+        self.history = history
+        self.log = history.log
+        
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+
+        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
+        self._changes_filename = os.path.join(cache_path, 'changes')
+        self._changes_diffs_filename = os.path.join(cache_path, 'changes-diffs')
+        
+        # use a lockfile since the cache folder could be shared across different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'lock'))
+        self._closed = False
+        
+        # this is fluff; don't slow down startup time with it.
+        def log_sizes():
+            s1, s2 = self.sizes()
+            self.log.info('Using change cache %s; %d/%d entries.' % (cache_path, s1, s2))
+        threading.Thread(target=log_sizes).start()
+    
+    @with_lock
+    def close(self):
+        self.log.debug('Closing cache file.')
+        self._closed = True
+    
+    @with_lock
+    def closed(self):
+        return self._closed
+
+    @with_lock
+    def flush(self):
+        pass
+    
+    @with_lock
+    def get_changes(self, revid_list, get_diffs=False):
+        """
+        get a list of changes by their revision_ids.  any changes missing
+        from the cache are fetched by calling L{History.get_change_uncached}
+        and inserted into the cache before returning.
+        """
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
+
+        out = []
+        fetch_list = []
+        sfetch_list = []
+        for revid in revid_list:
+            # if the revid is in unicode, use the utf-8 encoding as the key
+            srevid = util.to_utf8(revid)
+            
+            if srevid in cache:
+                out.append(cache[srevid])
+            else:
+                #self.log.debug('Entry cache miss: %r' % (revid,))
+                out.append(None)
+                fetch_list.append(revid)
+                sfetch_list.append(srevid)
+        
+        if len(fetch_list) > 0:
+            # some revisions weren't in the cache; fetch them
+            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
+            if changes is None:
+                return changes
+            for i in xrange(len(revid_list)):
+                if out[i] is None:
+                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
+        
+        cache.close()
+        return out
+    
+    @with_lock
+    def full(self, get_diffs=False):
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
+        try:
+            return (len(cache) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in cache)
+        finally:
+            cache.close()
+
+    @with_lock
+    def sizes(self):
+        cache = shelve.open(self._changes_filename, 'c', protocol=2)
+        s1 = len(cache)
+        cache.close()
+        cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        s2 = len(cache)
+        cache.close()
+        return s1, s2
+        
+    def check_rebuild(self, max_time=3600):
+        """
+        check if we need to fill in any missing pieces of the cache.  pull in
+        any missing changes, but don't work any longer than C{max_time}
+        seconds.
+        """
+        if self.closed() or self.full():
+            return
+        
+        self.log.info('Building revision cache...')
+        start_time = time.time()
+        last_update = time.time()
+        count = 0
+
+        work = list(self.history.get_revision_history())
+        jump = 100
+        for i in xrange(0, len(work), jump):
+            r = work[i:i + jump]
+            # must call into history so we grab the branch lock (otherwise, lock inversion)
+            self.history.get_changes(r)
+            if self.closed():
+                self.flush()
+                return
+            count += jump
+            now = time.time()
+            if now - start_time > max_time:
+                self.log.info('Cache rebuilding will pause for now.')
+                self.flush()
+                return
+            if now - last_update > 60:
+                self.log.info('Revision cache rebuilding continues: %d/%d' % (min(count, len(work)), len(work)))
+                last_update = time.time()
+                self.flush()
+            # give someone else a chance at the lock
+            time.sleep(1)
+        self.log.info('Revision cache rebuild completed.')
+        self.flush()
+
+

=== modified file 'loggerhead/config/log.cfg'
--- loggerhead/config/log.cfg	2006-12-11 06:44:19 +0000
+++ loggerhead/config/log.cfg	2007-01-14 05:40:40 +0000
@@ -11,19 +11,19 @@
 format='*(asctime)s *(name)s *(levelname)s *(message)s'
 
 [[handlers]]
-[[[debug_out]]]
-class='StreamHandler'
-level='DEBUG'
-args='(sys.stdout,)'
-formatter='full_content'
-
-[[[access_out]]]
-class='StreamHandler'
-level='INFO'
-args='(sys.stdout,)'
-formatter='message_only'
-
-[[[error_out]]]
-class='StreamHandler'
-level='ERROR'
-args='(sys.stdout,)'
+#[[[debug_out]]]
+#class='FileHandler'
+#level='DEBUG'
+#args='("/tmp/log.log",)'
+#formatter='full_content'
+
+#[[[access_out]]]
+#class='StreamHandler'
+#level='INFO'
+#args='(sys.stdout,)'
+#formatter='message_only'
+
+#[[[error_out]]]
+#class='StreamHandler'
+#level='ERROR'
+#args='(sys.stdout,)'

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/__init__.py	2007-01-14 05:40:40 +0000
@@ -18,70 +18,96 @@
 #
 
 import logging
+import os
+import re
+import sys
 import time
 
-from configobj import ConfigObj
-
 import turbogears
 from turbogears import controllers
 from cherrypy import HTTPRedirect, NotFound
+from configobj import ConfigObj
 
 from loggerhead import util
-
-my_config = ConfigObj('loggerhead.conf', encoding='utf-8')
-util.set_config(my_config)
-
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.history import History
+from loggerhead.branchview import BranchView
+from loggerhead.history import History, is_branch
 
 log = logging.getLogger("loggerhead.controllers")
 
+
+def cherrypy_friendly(s):
+    """
+    convert a config section name into a name that pleases cherrypy.
+    """
+    return re.sub(r'[^\w\d_]', '_', s)
+
+
+class Project (object):
+    def __init__(self, name, config):
+        self.name = name
+        self.friendly_name = config.get('name', name)
+        self.description = config.get('description', '')
+        self.long_description = config.get('long_description', '')
+        self._config = config
+        
+        self._views = []
+        for view_name in config.sections:
+            log.debug('Configuring (project %r) branch %r...', name, view_name)
+            self._add_view(view_name, config[view_name], config[view_name].get('folder'))
+        
+        auto_folder = config.get('auto_publish_folder', None)
+        if auto_folder is not None:
+            auto_list = []
+            # scan a folder for bazaar branches, and add them automatically
+            for path, folders, filenames in os.walk(auto_folder):
+                for folder in folders:
+                    folder = os.path.join(path, folder)
+                    if is_branch(folder):
+                        auto_list.append(folder)
+            auto_list.sort()
+            for folder in auto_list:
+                view_name = os.path.basename(folder)
+                log.debug('Auto-configuring (project %r) branch %r...', name, view_name)
+                self._add_view(view_name, ConfigObj(), folder)
+    
+    def _add_view(self, view_name, view_config, folder):
+        c_view_name = cherrypy_friendly(view_name)
+        view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
+        self._views.append(view)
+        setattr(self, c_view_name, view)
+        
+    views = property(lambda self: self._views)
+
+
 class Root (controllers.RootController):
-    changes = ChangeLogUI()
-    atom = AtomUI()
-    revision = RevisionUI()
-    files = InventoryUI()
-    annotate = AnnotateUI()
-    
-    @turbogears.expose()
+    def __init__(self):
+        self._projects = []
+        for project_name in sys._loggerhead_config.sections:
+            c_project_name = cherrypy_friendly(project_name)
+            project = Project(c_project_name, sys._loggerhead_config[project_name])
+            self._projects.append(project)
+            setattr(self, c_project_name, project)
+        
+    @turbogears.expose(template='loggerhead.templates.browse')
     def index(self):
-        raise HTTPRedirect(turbogears.url('/changes'))
-
-
-# force history to be read:
-util.get_history()
-
-
-
-def rebuild_cache():
-    log.info('Rebuilding revision cache...')
-    last_update = time.time()
-    h = util.get_history()
-    count = 0
-    
-    work = h.get_revision_history()
-    for r in work:
-        h.get_change(r)
-        if h.out_of_date():
-            return
-        count += 1
-        if time.time() - last_update > 60:
-            log.info('Revision cache rebuilding continues: %d/%d' % (count, len(work)))
-            last_update = time.time()
-            h.flush_cache()
-    log.info('Revision cache rebuild completed.')
-
-
-# re-index every hour (for now -- maybe should be even longer?)
-index_freq = 3600
-
-turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=rebuild_cache)
+        return {
+            'projects': self._projects,
+            'util': util,
+            'title': sys._loggerhead_config.get('title', ''),
+        }
+
+    def _check_rebuild(self):
+        for p in self._projects:
+            for v in p.views:
+                v.check_rebuild()
+
+
+# singleton:
+Root = Root()
+
 
 # for use in profiling the very-slow get_change() method:
-#h = util.get_history()
-#h._get_change_profiled(h.last_revid)
+#h = Root.bazaar.bzr_dev.get_history()
+#w = list(h.get_revision_history())
+#h._get_changes_profiled(w[:100])
 

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-01-21 00:05:52 +0000
@@ -41,40 +41,52 @@
         
 class AnnotateUI (object):
 
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
         z = time.time()
-        h = util.get_history()
+        h = self._branch.get_history()
+        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
         
-        path = kw.get('path', None)
-        if (path == '/') or (path == '') or (path is None):
-            raise HTTPRedirect(turbogears.url('/changes'))
+        file_id = kw.get('file_id', None)
+        if file_id is None:
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         try:
-            revlist, revid = h.get_navigation(revid, path)
-            file_id = h.get_inventory(revid).path2id(path)
+            revid_list, revid = h.get_file_view(revid, file_id)
         except Exception, x:
-            log.error('Exception fetching changes: %r, %s' % (x, x))
-            raise HTTPRedirect(turbogears.url('/changes'))
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
             
         # no navbar for revisions
         navigation = util.Container()
+        
+        path = h.get_path(revid, file_id)
+        filename = os.path.basename(path)
 
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch': self._branch,
             'util': util,
             'revid': revid,
+            'file_id': file_id,
             'path': path,
+            'filename': filename,
             'history': h,
             'navigation': navigation,
-            'change': h.get_change(revid),
+            'change': h.get_changes([ revid ])[0],
             'contents': list(h.annotate_file(file_id, revid)),
         }
         h.flush_cache()
-        log.info('/annotate: %r secs' % (time.time() - z,))
+        self.log.info('/annotate: %r secs' % (time.time() - z,))
         return vals

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-20 21:17:53 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cherrypy
 import turbogears
 
 from loggerhead import util
@@ -24,21 +25,22 @@
 
 class AtomUI (object):
     
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
     @turbogears.expose(template='loggerhead.templates.atom', format="xml", content_type="application/atom+xml")
     def default(self, *args):
-        h = util.get_history()
+        h = self._branch.get_history()
+        pagesize = int(self._branch.config.get('pagesize', '20'))
 
-        # really, there is no point giving a revid here...
-        if len(args) > 0:
-            revid = args[0]
-        else:
-            revid = h.last_revid
-        revlist = h.get_short_revision_history_from(revid)
-        entries = list(h.get_changelist(list(revlist)[:20]))
+        revid_list, start_revid = h.get_file_view(None, None)
+        entries = list(h.get_changes(list(revid_list)[:pagesize]))
 
         vals = {
-            'external_url': util.get_config().get('external_url'),
-            'branch_name': util.get_config().get('branch_name'),
+            'external_url': cherrypy.request.base,
+            'branch': self._branch,
             'changes': entries,
             'util': util,
             'history': h,

=== added file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	1970-01-01 00:00:00 +0000
+++ loggerhead/controllers/bundle_ui.py	2007-01-21 00:05:52 +0000
@@ -0,0 +1,60 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import time
+
+import turbogears
+from cherrypy import HTTPRedirect, response
+
+from loggerhead import util
+
+
+class BundleUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    @turbogears.expose()
+    def default(self, *args, **kw):
+        # /bundle/<rev_id>/filename
+        z = time.time()
+        h = self._branch.get_history()
+        compare_revid = kw.get('compare_revid', None)
+
+        if len(args) < 1:
+            raise HTTPRedirect(self._branch.url('/changes'))
+        revid = h.fix_revid(args[0])
+        compare_revid = None
+        if len(args) >= 3:
+            compare_revid = h.fix_revid(args[1])
+
+        try:
+            bundle_data = h.get_bundle(revid, compare_revid)
+        except Exception, x:
+            self.log.error('Exception fetching bundle: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+            
+        response.headers['Content-Type'] = 'text/plain'
+        response.headers['Content-Length'] = len(bundle_data)
+        response.body = bundle_data
+        self.log.info('/bundle: %r seconds' % (time.time() - z,))
+        return response.body

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-01-21 00:05:52 +0000
@@ -17,10 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import base64
-import logging
 import os
-import posixpath
 import time
 
 import turbogears
@@ -28,78 +25,77 @@
 
 from loggerhead import util
 
-log = logging.getLogger("loggerhead.controllers")
-
-
-# just thinking out loud here...
-#
-# so, when browsing around, there are 3 pieces of context:
-#     - starting revid 
-#         the current beginning of navigation (navigation continues back to
-#         the original revision) -- this may not be along the primary revision
-#         path since the user may have navigated into a branch
-#     - path
-#         if navigating the revisions that touched a file
-#     - current revid
-#         current location along the navigation path (while browsing)
-#
-# current revid is given on the url path.  'path' and 'starting revid' are
-# handed along as params.
+
 
 
 class ChangeLogUI (object):
     
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+        
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
         z = time.time()
-        h = util.get_history()
+        h = self._branch.get_history()
+        config = self._branch.config
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
 
-        path = kw.get('path', None)
+        file_id = kw.get('file_id', None)
+        query = kw.get('q', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
-        pagesize = int(util.get_config().get('pagesize', '20'))
+        orig_start_revid = start_revid
+        pagesize = int(config.get('pagesize', '20'))
+        search_failed = False
         
         try:
-            revlist, start_revid = h.get_navigation(start_revid, path)
-            if revid is None:
-                revid = start_revid
-            if revid not in revlist:
-                # if the given revid is not in the revlist, use a revlist that
-                # starts at the given revid.
-                revlist, start_revid = h.get_navigation(revid, path)
-            entry_list = list(h.get_revids_from(revlist, revid))[:pagesize]
-            entries = h.get_changelist(entry_list)
+            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
+            kw['start_revid'] = start_revid
+            util.set_context(kw)
+            
+            if (query is not None) and (len(revid_list) == 0):
+                search_failed = True
+
+            if len(revid_list) == 0:
+                scan_list = revid_list
+            else:
+                scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
+            entry_list = scan_list[:pagesize]
+            entries = h.get_changes(entry_list)
         except Exception, x:
-            log.error('Exception fetching changes: %r, %s' % (x, x))
-            raise HTTPRedirect(turbogears.url('/changes'))
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
-        navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revlist=revlist,
-                                    path=path, scan_url='/changes', feed=True)
+        navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
+                                    file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
+        if query is not None:
+            navigation.query = query
         util.fill_in_navigation(h, navigation)
         
         entries = list(entries)
         # add parent & merge-point branch-nick info, in case it's useful
-        for change in entries:
-            for p in change.parents:
-                p.branch_nick = h.get_change(p.revid).branch_nick
-            for p in change.merge_points:
-                p.branch_nick = h.get_change(p.revid).branch_nick
+        h.get_branch_nicks(entries)
 
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch': self._branch,
             'changes': list(entries),
             'util': util,
             'history': h,
             'revid': revid,
             'navigation': navigation,
-            'path': path,
-            'last_revid': h.last_revid,
+            'file_id': file_id,
             'start_revid': start_revid,
+            'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
+            'query': query,
+            'search_failed': search_failed,
         }
         h.flush_cache()
-        log.info('/changes %r: %r secs' % (revid, time.time() - z))
+        self.log.info('/changes %r: %r secs' % (revid, time.time() - z))
         return vals

=== added file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	1970-01-01 00:00:00 +0000
+++ loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
@@ -0,0 +1,64 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+# Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import datetime
+import logging
+import mimetypes
+import os
+import posixpath
+import textwrap
+import time
+
+import turbogears
+from cherrypy import HTTPRedirect, response, session
+
+from loggerhead import util
+
+
+log = logging.getLogger("loggerhead.controllers")
+
+
+class DownloadUI (object):
+
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    @turbogears.expose()
+    def default(self, *args, **kw):
+        # /download/<rev_id>/<file_id>/[filename]
+        z = time.time()
+        h = self._branch.get_history()
+        
+        if len(args) < 2:
+            raise HTTPRedirect(self._branch.url('/changes'))
+        
+        revid = h.fix_revid(args[0])
+        file_id = args[1]
+        path, filename, content = h.get_file(file_id, revid)
+        mime_type, encoding = mimetypes.guess_type(filename)
+        if mime_type is None:
+            mime_type = 'application/octet-stream'
+
+        self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+        response.headers['Content-Type'] = mime_type
+        response.headers['Content-Length'] = len(content)
+        response.body = content
+        return response.body

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/inventory_ui.py	2007-01-21 00:05:52 +0000
@@ -41,56 +41,69 @@
         
 class InventoryUI (object):
 
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.inventory')
     def default(self, *args, **kw):
         z = time.time()
-        h = util.get_history()
+        h = self._branch.get_history()
+        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
         
-        path = kw.get('path', None)
-        if (path == '/') or (path == ''):
-            path = None
+        file_id = kw.get('file_id', None)
+        sort_type = kw.get('sort', None)
 
         try:
-            revlist, revid = h.get_navigation(revid, path)
+            revid_list, revid = h.get_file_view(revid, file_id)
             rev = h.get_revision(revid)
             inv = h.get_inventory(revid)
         except Exception, x:
-            log.error('Exception fetching changes: %r, %s' % (x, x))
-            raise HTTPRedirect(turbogears.url('/changes'))
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
-        if path is None:
-            path = '/'
-            file_id = None
-        else:
-            file_id = inv.path2id(path)
-            
         # no navbar for revisions
         navigation = util.Container()
 
+        change = h.get_changes([ revid ])[0]
         # add parent & merge-point branch-nick info, in case it's useful
-        change = h.get_change(revid)
-        for p in change.parents:
-            p.branch_nick = h.get_change(p.revid).branch_nick
-        for p in change.merge_points:
-            p.branch_nick = h.get_change(p.revid).branch_nick
+        h.get_branch_nicks([ change ])
+        
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        idpath = inv.get_idpath(file_id)
+        if len(idpath) > 1:
+            updir = dirname(path)
+            updir_file_id = idpath[-2]
+        else:
+            updir = None
+            updir_file_id = None
+        if updir == '/':
+            updir_file_id = None
 
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch': self._branch,
             'util': util,
             'revid': revid,
             'change': change,
+            'file_id': file_id,
             'path': path,
-            'updir': dirname(path),
-            'filelist': h.get_filelist(inv, path),
+            'updir': updir,
+            'updir_file_id': updir_file_id,
+            'filelist': h.get_filelist(inv, path, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,
         }
         h.flush_cache()
-        log.info('/inventory %r: %r secs' % (revid, time.time() - z))
+        self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))
         return vals

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-15 09:20:04 +0000
+++ loggerhead/controllers/revision_ui.py	2007-01-21 00:05:52 +0000
@@ -28,54 +28,71 @@
 
 from loggerhead import util
 
-log = logging.getLogger("loggerhead.controllers")
-
 
 class RevisionUI (object):
 
+    def __init__(self, branch):
+        # BranchView object
+        self._branch = branch
+        self.log = branch.log
+        
+    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
         z = time.time()
-        h = util.get_history()
+        h = self._branch.get_history()
+        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
         
-        path = kw.get('path', None)
+        file_id = kw.get('file_id', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
+        query = kw.get('q', None)
+        remember = kw.get('remember', None)
+        compare_revid = kw.get('compare_revid', None)
         
         try:
-            revlist, start_revid = h.get_navigation(start_revid, path)
-            if revid is None:
-                revid = start_revid
+            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
         except Exception, x:
-            log.error('Exception fetching changes: %r, %s' % (x, x))
-            raise HTTPRedirect(turbogears.url('/changes'))
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
         
-        navigation = util.Container(revlist=revlist, revid=revid, start_revid=start_revid, path=path,
-                                    pagesize=1, scan_url='/revision', feed=1)
+        navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
+                                    pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
+        if query is not None:
+            navigation.query = query
         util.fill_in_navigation(h, navigation)
 
-        change = h.get_change(revid, get_diffs=True)
-        
+        if compare_revid is not None:
+            change = h.get_diff(compare_revid, revid)
+        else:
+            change = h.get_changes([ revid ], get_diffs=True)[0]
         # add parent & merge-point branch-nick info, in case it's useful
-        for p in change.parents:
-            p.branch_nick = h.get_change(p.revid).branch_nick
-        for p in change.merge_points:
-            p.branch_nick = h.get_change(p.revid).branch_nick
+        h.get_branch_nicks([ change ])
+
+        # let's make side-by-side diff be the default
+        side_by_side = not kw.get('unified', False)
+        if side_by_side:
+            h.add_side_by_side([ change ])
         
         vals = {
-            'branch_name': util.get_config().get('branch_name'),
+            'branch': self._branch,
             'revid': revid,
             'change': change,
             'start_revid': start_revid,
-            'path': path,
+            'file_id': file_id,
             'util': util,
             'history': h,
             'navigation': navigation,
+            'query': query,
+            'remember': remember,
+            'compare_revid': compare_revid,
+            'side_by_side': side_by_side,
         }
         h.flush_cache()
-        log.info('/revision: %r seconds' % (time.time() - z,))
+        self.log.info('/revision: %r seconds' % (time.time() - z,))
         return vals

=== added file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	1970-01-01 00:00:00 +0000
+++ loggerhead/daemon.py	2007-01-14 05:40:40 +0000
@@ -0,0 +1,62 @@
+# daemon code from ASPN
+
+import os
+import sys
+
+
+def daemonize(pidfile, home):
+    """
+    Detach this process from the controlling terminal and run it in the
+    background as a daemon.
+    """
+
+    UMASK = 0
+    WORKDIR = "/"
+    REDIRECT_TO = getattr(os, 'devnull', '/dev/null')
+    MAXFD = 1024
+
+    try:
+        pid = os.fork()
+    except OSError, e:
+        raise Exception("%s [%d]" % (e.strerror, e.errno))
+
+    if (pid == 0):	# The first child.
+        os.setsid()
+
+        try:
+            pid = os.fork()	# Fork a second child.
+        except OSError, e:
+            raise Exception, "%s [%d]" % (e.strerror, e.errno)
+
+        if (pid == 0):	# The second child.
+            os.chdir(WORKDIR)
+            os.umask(UMASK)
+        else:
+            os._exit(0)	# Exit parent (the first child) of the second child.
+    else:
+        os._exit(0)	# Exit parent of the first child.
+
+    #import resource		# Resource usage information.
+    #maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
+    #if (maxfd == resource.RLIM_INFINITY):
+    #    maxfd = MAXFD
+  
+    # Iterate through and close all file descriptors.
+    #for fd in range(3, maxfd):
+    #    try:
+    #        os.close(fd)
+    #    except OSError:	# ERROR, fd wasn't open to begin with (ignored)
+    #        pass
+
+    # This call to open is guaranteed to return the lowest file descriptor,
+    # which will be 0 (stdin), since it was closed above.
+    #os.open(REDIRECT_TO, os.O_RDWR)	# standard input (0)
+
+    # Duplicate standard input to standard output and standard error.
+    #os.dup2(0, 1)			# standard output (1)
+    #os.dup2(0, 2)			# standard error (2)
+
+    f = open(pidfile, 'w')
+    f.write('%d\n' % (os.getpid(),))
+    f.write('%s\n' % (home,))
+    f.close()

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-15 09:20:04 +0000
+++ loggerhead/history.py	2007-01-24 19:26:27 +0000
@@ -1,6 +1,8 @@
 #
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
+# Copyright (C) 2005  Jake Edge <jake@edge2.net>
+# Copyright (C) 2005  Matt Mackall <mpm@selenic.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +19,14 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+#
+# This file (and many of the web templates) contains work based on the
+# "bazaar-webserve" project by Goffredo Baroncelli, which is in turn based
+# on "hgweb" by Jake Edge and Matt Mackall.
+#
+
+
+import bisect
 import cgi
 import datetime
 import logging
@@ -31,13 +41,13 @@
 from StringIO import StringIO
 
 from loggerhead import util
-extra_path = util.get_config().get('bzrpath', None)
-if extra_path:
-    sys.path.insert(0, extra_path)
+from loggerhead.util import decorator
 
 import bzrlib
 import bzrlib.annotate
 import bzrlib.branch
+import bzrlib.bundle.serializer
+import bzrlib.decorators
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
@@ -46,32 +56,19 @@
 import bzrlib.ui
 
 
-log = logging.getLogger("loggerhead.controllers")
-
-
-# cache lock binds tighter than branch lock
-def with_cache_lock(unbound):
-    def cache_locked(self, *args, **kw):
-        self._cache_lock.acquire()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._cache_lock.release()
-    cache_locked.__doc__ = unbound.__doc__
-    cache_locked.__name__ = unbound.__name__
-    return cache_locked
-
-
-def with_branch_lock(unbound):
-    def branch_locked(self, *args, **kw):
-        self._lock.acquire()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._lock.release()
-    branch_locked.__doc__ = unbound.__doc__
-    branch_locked.__name__ = unbound.__name__
-    return branch_locked
+with_branch_lock = util.with_lock('_lock', 'branch')
+
+@decorator
+def with_bzrlib_read_lock(unbound):
+    def bzrlib_read_locked(self, *args, **kw):
+        #self.log.debug('-> %r bzr lock', id(threading.currentThread()))
+        self._branch.repository.lock_read()
+        try:
+            return unbound(self, *args, **kw)
+        finally:
+            self._branch.repository.unlock()
+            #self.log.debug('<- %r bzr lock', id(threading.currentThread()))
+    return bzrlib_read_locked
 
 
 # bzrlib's UIFactory is not thread-safe
@@ -86,28 +83,117 @@
 bzrlib.ui.ui_factory = ThreadSafeUIFactory()
 
 
+def _process_side_by_side_buffers(line_list, delete_list, insert_list):
+    while len(delete_list) < len(insert_list):
+        delete_list.append((None, '', 'context'))
+    while len(insert_list) < len(delete_list):
+        insert_list.append((None, '', 'context'))
+    while len(delete_list) > 0:
+        d = delete_list.pop(0)
+        i = insert_list.pop(0)
+        line_list.append(util.Container(old_lineno=d[0], new_lineno=i[0],
+                                        old_line=d[1], new_line=i[1],
+                                        old_type=d[2], new_type=i[2]))
+
+
+def _make_side_by_side(chunk_list):
+    """
+    turn a normal unified-style diff (post-processed by parse_delta) into a
+    side-by-side diff structure.  the new structure is::
+    
+        chunks: list(
+            diff: list(
+                old_lineno: int,
+                new_lineno: int,
+                old_line: str,
+                new_line: str,
+                type: str('context' or 'changed'),
+            )
+        )
+    """
+    out_chunk_list = []
+    for chunk in chunk_list:
+        line_list = []
+        delete_list, insert_list = [], []
+        for line in chunk.diff:
+            if line.type == 'context':
+                if len(delete_list) or len(insert_list):
+                    _process_side_by_side_buffers(line_list, delete_list, insert_list)
+                    delete_list, insert_list = [], []
+                line_list.append(util.Container(old_lineno=line.old_lineno, new_lineno=line.new_lineno,
+                                                old_line=line.line, new_line=line.line,
+                                                old_type=line.type, new_type=line.type))
+            elif line.type == 'delete':
+                delete_list.append((line.old_lineno, line.line, line.type))
+            elif line.type == 'insert':
+                insert_list.append((line.new_lineno, line.line, line.type))
+        if len(delete_list) or len(insert_list):
+            _process_side_by_side_buffers(line_list, delete_list, insert_list)
+        out_chunk_list.append(util.Container(diff=line_list))
+    return out_chunk_list
+
+
+def is_branch(folder):
+    try:
+        bzrlib.branch.Branch.open(folder)
+        return True
+    except:
+        return False
+
+
+def clean_message(message):
+    # clean up a commit message and return it and a short (1-line) version
+    message = message.splitlines()
+    if len(message) == 1:
+        # robey-style 1-line long message
+        message = textwrap.wrap(message[0])
+        
+    # make short form of commit message
+    short_message = message[0]
+    if len(short_message) > 60:
+        short_message = short_message[:60] + '...'
+    
+    return message, short_message
+
+
+# from bzrlib
+class _RevListToTimestamps(object):
+    """This takes a list of revisions, and allows you to bisect by date"""
+
+    __slots__ = ['revid_list', 'repository']
+
+    def __init__(self, revid_list, repository):
+        self.revid_list = revid_list
+        self.repository = repository
+
+    def __getitem__(self, index):
+        """Get the date of the index'd item"""
+        return datetime.datetime.fromtimestamp(self.repository.get_revision(self.revid_list[index]).timestamp)
+
+    def __len__(self):
+        return len(self.revid_list)
+
+
 class History (object):
     
     def __init__(self):
         self._change_cache = None
-        self._cache_lock = threading.Lock()
+        self._index = None
         self._lock = threading.RLock()
     
-    def __del__(self):
-        if self._change_cache is not None:
-            self._change_cache.close()
-            self._change_cache_diffs.close()
-            self._change_cache = None
-            self._change_cache_diffs = None
-
     @classmethod
-    def from_branch(cls, branch):
+    def from_branch(cls, branch, name=None):
         z = time.time()
         self = cls()
         self._branch = branch
         self._history = branch.revision_history()
-        self._revision_graph = branch.repository.get_revision_graph()
         self._last_revid = self._history[-1]
+        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        
+        if name is None:
+            name = self._branch.nick
+        self._name = name
+        self.log = logging.getLogger('loggerhead.%s' % (name,))
         
         self._full_history = []
         self._revision_info = {}
@@ -130,13 +216,13 @@
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
 
-        log.info('built revision graph cache: %r secs' % (time.time() - z,))
+        self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
     
     @classmethod
-    def from_folder(cls, path):
+    def from_folder(cls, path, name=None):
         b = bzrlib.branch.Branch.open(path)
-        return cls.from_branch(b)
+        return cls.from_branch(b, name)
 
     @with_branch_lock
     def out_of_date(self):
@@ -144,52 +230,46 @@
             return True
         return False
 
-    @with_cache_lock
-    def use_cache(self, path):
-        if not os.path.exists(path):
-            os.mkdir(path)
-        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
-        cachefile = os.path.join(path, 'changes')
-        cachefile_diffs = os.path.join(path, 'changes-diffs')
-        
-        # why can't shelve allow 'cw'?
-        if not os.path.exists(cachefile):
-            self._change_cache = shelve.open(cachefile, 'c', protocol=2)
-        else:
-            self._change_cache = shelve.open(cachefile, 'w', protocol=2)
-        if not os.path.exists(cachefile_diffs):
-            self._change_cache_diffs = shelve.open(cachefile_diffs, 'c', protocol=2)
-        else:
-            self._change_cache_diffs = shelve.open(cachefile_diffs, 'w', protocol=2)
-            
-        # once we process a change (revision), it should be the same forever.
-        log.info('Using change cache %s; %d, %d entries.' % (path, len(self._change_cache), len(self._change_cache_diffs)))
-        self._change_cache_filename = cachefile
-        self._change_cache_diffs_filename = cachefile_diffs
-
-    @with_cache_lock
-    def dont_use_cache(self):
-        # called when a new history object needs to be created.  we can't use
-        # the cache files anymore; they belong to the new history object.
-        if self._change_cache is None:
-            return
-        self._change_cache.close()
-        self._change_cache_diffs.close()
-        self._change_cache = None
-        self._change_cache_diffs = None
-
-    @with_cache_lock
+    def use_cache(self, cache):
+        self._change_cache = cache
+    
+    def use_search_index(self, index):
+        self._index = index
+
+    @with_branch_lock
+    def detach(self):
+        # called when a new history object needs to be created, because the
+        # branch history has changed.  we need to immediately close and stop
+        # using our caches, because a new history object will be created to
+        # replace us, using the same cache files.
+        # (may also be called during server shutdown.)
+        if self._change_cache is not None:
+            self._change_cache.close()
+            self._change_cache = None
+        if self._index is not None:
+            self._index.close()
+            self._index = None
+
     def flush_cache(self):
         if self._change_cache is None:
             return
-        self._change_cache.sync()
-        self._change_cache_diffs.sync()
+        self._change_cache.flush()
+    
+    def check_rebuild(self):
+        if self._change_cache is not None:
+            self._change_cache.check_rebuild()
+        if self._index is not None:
+            self._index.check_rebuild()
     
     last_revid = property(lambda self: self._last_revid, None, None)
     
     count = property(lambda self: self._count, None, None)
 
     @with_branch_lock
+    def get_config(self):
+        return self._branch.get_config()
+    
+    @with_branch_lock
     def get_revision(self, revid):
         return self._branch.repository.get_revision(revid)
     
@@ -233,7 +313,7 @@
             if len(parents) == 0:
                 return
             revid = parents[0]
-
+    
     @with_branch_lock
     def get_short_revision_history_by_fileid(self, file_id):
         # wow.  is this really the only way we can get this list?  by
@@ -245,7 +325,97 @@
         revids = [r for r in self._full_history if r in w_revids]
         return revids
 
+    @with_branch_lock
+    def get_revision_history_since(self, revid_list, date):
+        # if a user asks for revisions starting at 01-sep, they mean inclusive,
+        # so start at midnight on 02-sep.
+        date = date + datetime.timedelta(days=1)
+        # our revid list is sorted in REVERSE date order, so go thru some hoops here...
+        revid_list.reverse()
+        index = bisect.bisect(_RevListToTimestamps(revid_list, self._branch.repository), date)
+        if index == 0:
+            return []
+        revid_list.reverse()
+        index = -index
+        return revid_list[index:]
+    
+    @with_branch_lock
+    def get_revision_history_matching(self, revid_list, text):
+        self.log.debug('searching %d revisions for %r', len(revid_list), text)
+        z = time.time()
+        # this is going to be painfully slow. :(
+        out = []
+        text = text.lower()
+        for revid in revid_list:
+            change = self.get_changes([ revid ])[0]
+            if text in change.comment.lower():
+                out.append(revid)
+        self.log.debug('searched %d revisions for %r in %r secs', len(revid_list), text, time.time() - z)
+        return out
+
+    def get_revision_history_matching_indexed(self, revid_list, text):
+        self.log.debug('searching %d revisions for %r', len(revid_list), text)
+        z = time.time()
+        if self._index is None:
+            return self.get_revision_history_matching(revid_list, text)
+        out = self._index.find(text, revid_list)
+        self.log.debug('searched %d revisions for %r in %r secs: %d results', len(revid_list), text, time.time() - z, len(out))
+        # put them in some coherent order :)
+        out = [r for r in self._full_history if r in out]
+        return out
+    
+    @with_branch_lock
+    def get_search_revid_list(self, query, revid_list):
+        """
+        given a "quick-search" query, try a few obvious possible meanings:
+        
+            - revision id or # ("128.1.3")
+            - date (US style "mm/dd/yy", earth style "dd-mm-yy", or iso style "yyyy-mm-dd")
+            - comment text as a fallback
+
+        and return a revid list that matches.
+        """
+        # FIXME: there is some silliness in this action.  we have to look up
+        # all the relevant changes (time-consuming) only to return a list of
+        # revids which will be used to fetch a set of changes again.
+        
+        # if they entered a revid, just jump straight there; ignore the passed-in revid_list
+        revid = self.fix_revid(query)
+        if revid is not None:
+            changes = self.get_changes([ revid ])
+            if (changes is not None) and (len(changes) > 0):
+                return [ revid ]
+        
+        date = None
+        m = self.us_date_re.match(query)
+        if m is not None:
+            date = datetime.datetime(util.fix_year(int(m.group(3))), int(m.group(1)), int(m.group(2)))
+        else:
+            m = self.earth_date_re.match(query)
+            if m is not None:
+                date = datetime.datetime(util.fix_year(int(m.group(3))), int(m.group(2)), int(m.group(1)))
+            else:
+                m = self.iso_date_re.match(query)
+                if m is not None:
+                    date = datetime.datetime(util.fix_year(int(m.group(1))), int(m.group(2)), int(m.group(3)))
+        if date is not None:
+            if revid_list is None:
+                # if no limit to the query was given, search only the direct-parent path.
+                revid_list = list(self.get_revids_from(None, self._last_revid))
+            return self.get_revision_history_since(revid_list, date)
+        
+        # check comment fields.
+        if revid_list is None:
+            revid_list = self._full_history
+        return self.get_revision_history_matching_indexed(revid_list, query)
+    
     revno_re = re.compile(r'^[\d\.]+$')
+    # the date regex are without a final '$' so that queries like
+    # "2006-11-30 12:15" still mostly work.  (i think it's better to give
+    # them 90% of what they want instead of nothing at all.)
+    us_date_re = re.compile(r'^(\d{1,2})/(\d{1,2})/(\d\d(\d\d?))')
+    earth_date_re = re.compile(r'^(\d{1,2})-(\d{1,2})-(\d\d(\d\d?))')
+    iso_date_re = re.compile(r'^(\d\d\d\d)-(\d\d)-(\d\d)')
 
     def fix_revid(self, revid):
         # if a "revid" is actually a dotted revno, convert it to a revid
@@ -256,31 +426,89 @@
         return revid
     
     @with_branch_lock
-    def get_navigation(self, revid, path):
+    def get_file_view(self, revid, file_id):
         """
         Given an optional revid and optional path, return a (revlist, revid)
         for navigation through the current scope: from the revid (or the
         latest revision) back to the original revision.
         
-        If path is None, the entire revision history is the list scope.
+        If file_id is None, the entire revision history is the list scope.
         If revid is None, the latest revision is used.
         """
         if revid is None:
             revid = self._last_revid
-        if path is not None:
+        if file_id is not None:
             # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
             inv = self._branch.repository.get_revision_inventory(revid)
-            revlist = list(self.get_short_revision_history_by_fileid(inv.path2id(path)))
+            revlist = list(self.get_short_revision_history_by_fileid(file_id))
+            revlist = list(self.get_revids_from(revlist, revid))
         else:
             revlist = list(self.get_revids_from(None, revid))
         if revid is None:
             revid = revlist[0]
         return revlist, revid
+    
+    @with_branch_lock
+    def get_view(self, revid, start_revid, file_id, query=None):
+        """
+        use the URL parameters (revid, start_revid, file_id, and query) to
+        determine the revision list we're viewing (start_revid, file_id, query)
+        and where we are in it (revid).
+        
+        if a query is given, we're viewing query results.
+        if a file_id is given, we're viewing revisions for a specific file.
+        if a start_revid is given, we're viewing the branch from a
+            specific revision up the tree.
+        (these may be combined to view revisions for a specific file, from
+            a specific revision, with a specific search query.)
+            
+        returns a new (revid, start_revid, revid_list, scan_list) where:
+        
+            - revid: current position within the view
+            - start_revid: starting revision of this view
+            - revid_list: list of revision ids for this view
+        
+        file_id and query are never changed so aren't returned, but they may
+        contain vital context for future url navigation.
+        """
+        if query is None:
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
+            if revid is None:
+                revid = start_revid
+            if revid not in revid_list:
+                # if the given revid is not in the revlist, use a revlist that
+                # starts at the given revid.
+                revid_list, start_revid = self.get_file_view(revid, file_id)
+            return revid, start_revid, revid_list
+        
+        # potentially limit the search
+        if (start_revid is not None) or (file_id is not None):
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
+        else:
+            revid_list = None
+
+        revid_list = self.get_search_revid_list(query, revid_list)
+        if len(revid_list) > 0:
+            if revid not in revid_list:
+                revid = revid_list[0]
+            return revid, start_revid, revid_list
+        else:
+            # no results
+            return None, None, []
 
     @with_branch_lock
     def get_inventory(self, revid):
         return self._branch.repository.get_revision_inventory(revid)
 
+    @with_branch_lock
+    def get_path(self, revid, file_id):
+        if (file_id is None) or (file_id == ''):
+            return ''
+        path = self._branch.repository.get_revision_inventory(revid).id2path(file_id)
+        if (len(path) > 0) and not path.startswith('/'):
+            path = '/' + path
+        return path
+    
     def get_where_merged(self, revid):
         try:
             return self._where_merged[revid]
@@ -333,166 +561,162 @@
                 d[revnos] = ( revnolast, revid )
 
         return [ d[revnos][1] for revnos in d.keys() ]
-            
-    def get_changelist(self, revid_list):
-        for revid in revid_list:
-            yield self.get_change(revid)
+
+    def get_branch_nicks(self, changes):
+        """
+        given a list of changes from L{get_changes}, fill in the branch nicks
+        on all parents and merge points.
+        """
+        fetch_set = set()
+        for change in changes:
+            for p in change.parents:
+                fetch_set.add(p.revid)
+            for p in change.merge_points:
+                fetch_set.add(p.revid)
+        p_changes = self.get_changes(list(fetch_set))
+        p_change_dict = dict([(c.revid, c) for c in p_changes])
+        for change in changes:
+            for p in change.parents:
+                p.branch_nick = p_change_dict[p.revid].branch_nick
+            for p in change.merge_points:
+                p.branch_nick = p_change_dict[p.revid].branch_nick
     
     @with_branch_lock
-    def get_change(self, revid, get_diffs=False):
+    def get_changes(self, revid_list, get_diffs=False):
         if self._change_cache is None:
-            return self._get_change(revid, get_diffs)
-
-        # if the revid is in unicode, use the utf-8 encoding as the key
-        srevid = revid
-        if isinstance(revid, unicode):
-            srevid = revid.encode('utf-8')
-        return self._get_change_from_cache(revid, srevid, get_diffs)
-
-    @with_cache_lock
-    def _get_change_from_cache(self, revid, srevid, get_diffs):
-        if get_diffs:
-            cache = self._change_cache_diffs
-        else:
-            cache = self._change_cache
-            
-        if srevid in cache:
-            c = cache[srevid]
-        else:
-            if get_diffs and (srevid in self._change_cache):
-                # salvage the non-diff entry for a jump-start
-                c = self._change_cache[srevid]
-                if len(c.parents) == 0:
-                    left_parent = None
-                else:
-                    left_parent = c.parents[0].revid
-                c.changes = self.diff_revisions(revid, left_parent, get_diffs=True)
-                cache[srevid] = c
-            else:
-                #log.debug('Entry cache miss: %r' % (revid,))
-                c = self._get_change(revid, get_diffs=get_diffs)
-                cache[srevid] = c
-            
+            changes = self.get_changes_uncached(revid_list, get_diffs)
+        else:
+            changes = self._change_cache.get_changes(revid_list, get_diffs)
+        if changes is None:
+            return changes
+        
         # some data needs to be recalculated each time, because it may
         # change as new revisions are added.
-        merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
-        c.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
+        for i in xrange(len(revid_list)):
+            revid = revid_list[i]
+            change = changes[i]
+            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
+            change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
         
-        return c
-    
+        return changes
+
     # alright, let's profile this sucka.
-    def _get_change_profiled(self, revid, get_diffs=False):
+    def _get_changes_profiled(self, revid_list, get_diffs=False):
         from loggerhead.lsprof import profile
         import cPickle
-        ret, stats = profile(self._get_change, revid, get_diffs)
+        ret, stats = profile(self.get_changes_uncached, revid_list, get_diffs)
         stats.sort()
         stats.freeze()
         cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
+        self.log.info('lsprof complete!')
         return ret
 
-    def _get_change(self, revid, get_diffs=False):
+    def _get_deltas_for_revisions_with_trees(self, revisions):
+        """Produce a generator of revision deltas.
+        
+        Note that the input is a sequence of REVISIONS, not revision_ids.
+        Trees will be held in memory until the generator exits.
+        Each delta is relative to the revision's lefthand predecessor.
+        """
+        required_trees = set()
+        for revision in revisions:
+            required_trees.add(revision.revision_id)
+            required_trees.update(revision.parent_ids[:1])
+        trees = dict((t.get_revision_id(), t) for 
+                     t in self._branch.repository.revision_trees(required_trees))
+        ret = []
+        self._branch.repository.lock_read()
         try:
-            rev = self._branch.repository.get_revision(revid)
-        except (KeyError, bzrlib.errors.NoSuchRevision):
-            # ghosted parent?
-            entry = {
-                'revid': 'missing',
-                'revno': '',
-                'date': datetime.datetime.fromtimestamp(0),
-                'author': 'missing',
-                'branch_nick': None,
-                'short_comment': 'missing',
-                'comment': 'missing',
-                'comment_clean': 'missing',
-                'parents': [],
-                'merge_points': [],
-                'changes': [],
-            }
-            log.error('ghost entry: %r' % (revid,))
-            return util.Container(entry)
-            
-        commit_time = datetime.datetime.fromtimestamp(rev.timestamp)
+            for revision in revisions:
+                if not revision.parent_ids:
+                    old_tree = self._branch.repository.revision_tree(None)
+                else:
+                    old_tree = trees[revision.parent_ids[0]]
+                tree = trees[revision.revision_id]
+                ret.append((tree, old_tree, tree.changes_from(old_tree)))
+            return ret
+        finally:
+            self._branch.repository.unlock()
+    
+    def entry_from_revision(self, revision):
+        commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
         
-        parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
+        parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
 
         if len(parents) == 0:
             left_parent = None
         else:
-            left_parent = rev.parent_ids[0]
-        
-        message = rev.message.splitlines()
-        if len(message) == 1:
-            # robey-style 1-line long message
-            message = textwrap.wrap(message[0])
-        
-        # make short form of commit message
-        short_message = message[0]
-        if len(short_message) > 60:
-            short_message = short_message[:60] + '...'
+            left_parent = revision.parent_ids[0]
+        
+        message, short_message = clean_message(revision.message)
 
         entry = {
-            'revid': revid,
-            'revno': self.get_revno(revid),
+            'revid': revision.revision_id,
+            'revno': self.get_revno(revision.revision_id),
             'date': commit_time,
-            'author': rev.committer,
-            'branch_nick': rev.properties.get('branch-nick', None),
+            'author': revision.committer,
+            'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
-            'comment': rev.message,
+            'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': parents,
-            'changes': self.diff_revisions(revid, left_parent, get_diffs=get_diffs),
         }
         return util.Container(entry)
-    
-    def scan_range(self, revlist, revid, pagesize=20):
-        """
-        yield a list of (label, title, revid) for a scan range through the full
-        branch history, centered around the given revid.
-        
-        example: [ ('<<', 'Previous page', 'rrr'), ('-10', 'Forward 10', 'rrr'),
-                   ('*', None, None), ('+10', 'Back 10', 'rrr'),
-                   ('+30', 'Back 30', 'rrr'), ('>>', 'Next page', 'rrr') ]
-        
-        next/prev page are always using the pagesize.
-        """
-        count = len(revlist)
-        pos = self.get_revid_sequence(revlist, revid)
-
-        if pos > 0:
-            yield (u'\xab', 'Previous page', revlist[max(0, pos - pagesize)])
-        else:
-            yield (u'\xab', None, None)
-        
-        offset_sign = -1
-        for offset in util.scan_range(pos, count, pagesize):
-            if (offset > 0) and (offset_sign < 0):
-                offset_sign = 0
-                # show current position
-#                yield ('[%s]' % (self.get_revno(revlist[pos]),), None, None)
-#                yield (u'\u2022', None, None)
-                yield (u'\u00b7', None, None)
-            if offset < 0:
-                title = 'Back %d' % (-offset,)
-            else:
-                title = 'Forward %d' % (offset,)
-            yield ('%+d' % (offset,), title, revlist[pos + offset])
-        
-        if pos < count - 1:
-            yield (u'\xbb', 'Next page', revlist[min(count - 1, pos + pagesize)])
-        else:
-            yield (u'\xbb', None, None)
-    
-    @with_branch_lock
-    def diff_revisions(self, revid, otherrevid, get_diffs=True):
-        """
-        Return a nested data structure containing the changes between two
-        revisions::
-        
-            added: list(filename),
-            renamed: list((old_filename, new_filename)),
-            deleted: list(filename),
+
+    @with_branch_lock
+    @with_bzrlib_read_lock
+    def get_changes_uncached(self, revid_list, get_diffs=False):
+        try:
+            rev_list = self._branch.repository.get_revisions(revid_list)
+        except (KeyError, bzrlib.errors.NoSuchRevision):
+            return None
+        
+        delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
+        combined_list = zip(rev_list, delta_list)
+        
+        entries = []
+        for rev, (new_tree, old_tree, delta) in combined_list:
+            entry = self.entry_from_revision(rev)
+            entry.changes = self.parse_delta(delta, get_diffs, old_tree, new_tree)
+            entries.append(entry)
+        
+        return entries
+
+    @with_bzrlib_read_lock
+    def _get_diff(self, revid1, revid2):
+        rev_tree1 = self._branch.repository.revision_tree(revid1)
+        rev_tree2 = self._branch.repository.revision_tree(revid2)
+        delta = rev_tree2.changes_from(rev_tree1)
+        return rev_tree1, rev_tree2, delta
+    
+    def get_diff(self, revid1, revid2):
+        rev_tree1, rev_tree2, delta = self._get_diff(revid1, revid2)
+        entry = self.get_changes([ revid2 ], False)[0]
+        entry.changes = self.parse_delta(delta, True, rev_tree1, rev_tree2)
+        return entry
+    
+    @with_branch_lock
+    def get_file(self, file_id, revid):
+        "returns (path, filename, data)"
+        inv = self.get_inventory(revid)
+        inv_entry = inv[file_id]
+        rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        return path, inv_entry.name, rev_tree.get_file_text(file_id)
+    
+    @with_branch_lock
+    def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
+        """
+        Return a nested data structure containing the changes in a delta::
+        
+            added: list((filename, file_id)),
+            renamed: list((old_filename, new_filename, file_id)),
+            deleted: list((filename, file_id)),
             modified: list(
                 filename: str,
+                file_id: str,
                 chunks: list(
                     diff: list(
                         old_lineno: int,
@@ -505,11 +729,6 @@
         
         if C{get_diffs} is false, the C{chunks} will be omitted.
         """
-
-        new_tree = self._branch.repository.revision_tree(revid)
-        old_tree = self._branch.repository.revision_tree(otherrevid)
-        delta = new_tree.changes_from(old_tree)
-        
         added = []
         modified = []
         renamed = []
@@ -522,12 +741,6 @@
                 path += '@'
             return path
         
-        def tree_lines(tree, fid):
-            if not fid in tree:
-                return []
-            tree_file = bzrlib.textfile.text_file(tree.get_file(fid))
-            return tree_file.readlines()
-        
         def process_diff(diff):
             chunks = []
             chunk = None
@@ -567,33 +780,40 @@
                     
         def handle_modify(old_path, new_path, fid, kind):
             if not get_diffs:
-                modified.append(util.Container(filename=rich_filename(new_path, kind)))
+                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
                 return
-            old_lines = tree_lines(old_tree, fid)
-            new_lines = tree_lines(new_tree, fid)
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
             buffer = StringIO()
             bzrlib.diff.internal_diff(old_path, old_lines, new_path, new_lines, buffer)
             diff = buffer.getvalue()
-            modified.append(util.Container(filename=rich_filename(new_path, kind), chunks=process_diff(diff)))
+            modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=process_diff(diff), raw_diff=diff))
 
         for path, fid, kind in delta.added:
-            added.append(rich_filename(path, kind))
+            added.append((rich_filename(path, kind), fid))
         
         for path, fid, kind, text_modified, meta_modified in delta.modified:
             handle_modify(path, path, fid, kind)
         
         for oldpath, newpath, fid, kind, text_modified, meta_modified in delta.renamed:
-            renamed.append((rich_filename(oldpath, kind), rich_filename(newpath, kind)))
+            renamed.append((rich_filename(oldpath, kind), rich_filename(newpath, kind), fid))
             if meta_modified or text_modified:
                 handle_modify(oldpath, newpath, fid, kind)
         
         for path, fid, kind in delta.removed:
-            removed.append(rich_filename(path, kind))
+            removed.append((rich_filename(path, kind), fid))
         
         return util.Container(added=added, renamed=renamed, removed=removed, modified=modified)
 
+    @staticmethod
+    def add_side_by_side(changes):
+        # FIXME: this is a rotten API.
+        for change in changes:
+            for m in change.changes.modified:
+                m.sbs_chunks = _make_side_by_side(m.chunks)
+    
     @with_branch_lock
-    def get_filelist(self, inv, path):
+    def get_filelist(self, inv, path, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
@@ -602,8 +822,16 @@
             path = path[:-1]
         if path.startswith('/'):
             path = path[1:]
-        parity = 0
-        for filepath, entry in inv.entries():
+        
+        entries = inv.entries()
+        
+        fetch_set = set()
+        for filepath, entry in entries:
+            fetch_set.add(entry.revision)
+        change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
+        
+        file_list = []
+        for filepath, entry in entries:
             if posixpath.dirname(filepath) != path:
                 continue
             filename = posixpath.basename(filepath)
@@ -614,12 +842,28 @@
             
             # last change:
             revid = entry.revision
-            change = self.get_change(revid)
+            change = change_dict[revid]
             
-            yield util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
-                                 pathname=pathname, revid=revid, change=change, parity=parity)
+            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
+                                  pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
+            file_list.append(file)
+        
+        if sort_type == 'filename':
+            file_list.sort(key=lambda x: x.filename)
+        elif sort_type == 'size':
+            file_list.sort(key=lambda x: x.size)
+        elif sort_type == 'date':
+            file_list.sort(key=lambda x: x.change.date)
+        
+        parity = 0
+        for file in file_list:
+            file.parity = parity
             parity ^= 1
-        pass
+
+        return file_list
+
+
+    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b-\x0c\x0e-\x1f]')
 
     @with_branch_lock
     def annotate_file(self, file_id, revid):
@@ -629,12 +873,23 @@
         
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
-        revision_cache = {}
         
         # because we cache revision metadata ourselves, it's actually much
         # faster to call 'annotate_iter' on the weave directly than it is to
         # ask bzrlib to annotate for us.
         w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
+        
+        revid_set = set()
+        for line_revid, text in w.annotate_iter(file_revid):
+            revid_set.add(line_revid)
+            if self._BADCHARS_RE.match(text):
+                # bail out; this isn't displayable text
+                yield util.Container(parity=0, lineno=1, status='same',
+                                     text='<i>' + util.html_clean('(This is a binary file.)') + '</i>',
+                                     change=util.Container())
+                return
+        change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
+        
         last_line_revid = None
         for line_revid, text in w.annotate_iter(file_revid):
             if line_revid == last_line_revid:
@@ -644,16 +899,27 @@
                 status = 'changed'
                 parity ^= 1
                 last_line_revid = line_revid
-                change = revision_cache.get(line_revid, None)
-                if change is None:
-                    change = self.get_change(line_revid)
-                    revision_cache[line_revid] = change
+                change = change_cache[line_revid]
                 trunc_revno = change.revno
                 if len(trunc_revno) > 10:
                     trunc_revno = trunc_revno[:9] + '...'
                 
             yield util.Container(parity=parity, lineno=lineno, status=status,
-                                 trunc_revno=trunc_revno, change=change, text=util.html_clean(text))
+                                 change=change, text=util.html_clean(text))
             lineno += 1
         
-        log.debug('annotate: %r secs' % (time.time() - z,))
+        self.log.debug('annotate: %r secs' % (time.time() - z,))
+
+    @with_branch_lock
+    @with_bzrlib_read_lock
+    def get_bundle(self, revid, compare_revid=None):
+        if compare_revid is None:
+            parents = self._revision_graph[revid]
+            if len(parents) > 0:
+                compare_revid = parents[0]
+            else:
+                compare_revid = None
+        s = StringIO()
+        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
+        return s.getvalue()
+

=== added file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	1970-01-01 00:00:00 +0000
+++ loggerhead/lockfile.py	2007-01-14 01:20:39 +0000
@@ -0,0 +1,82 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import threading
+import time
+
+from loggerhead import util
+
+
+with_lock = util.with_lock('_tlock', 'LockFile')
+
+MAX_STALE_TIME = 5 * 60
+
+
+class LockFile (object):
+    """
+    simple lockfile implementation that mimics the API of threading.Lock, so
+    it can be used interchangably.  it's actually a reentrant lock, so the
+    lock may be acquired multiple times by the same thread, as long as it's
+    released an equal number of times.  unlike threading.Lock, this lock can
+    be used across processes.
+    
+    this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
+    but will not work over NFS, if anyone still uses that.  so don't put the
+    cache folder on an NFS server...
+    """
+
+    def __init__(self, filename):
+        self._filename = filename
+        # thread lock to maintain internal consistency
+        self._tlock = threading.Lock()
+        self._count = 0
+        if os.path.exists(filename):
+            # remove stale locks left over from a previous run
+            if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
+                os.remove(filename)
+    
+    @with_lock
+    def _try_acquire(self):
+        if self._count > 0:
+            self._count += 1
+            return True
+        try:
+            fd = os.open(self._filename, os.O_WRONLY | os.O_CREAT | os.O_EXCL, 0600)
+            os.close(fd)
+            self._count += 1
+            return True
+        except OSError:
+            return False
+    
+    def acquire(self):
+        # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
+        pause = 0.1
+        #max_pause = 5.0
+        max_pause = 0.1
+        while True:
+            if self._try_acquire():
+                return
+            time.sleep(pause)
+            pause = min(pause * 2.0, max_pause)
+
+    @with_lock
+    def release(self):
+        self._count -= 1
+        if self._count == 0:
+            os.remove(self._filename)

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2006-12-11 06:44:19 +0000
+++ loggerhead/release.py	2007-01-24 19:29:58 +0000
@@ -1,14 +1,12 @@
 # Release information about loggerhead
 
-version = "1.0"
-
-# description = "Your plan to rule the world"
-# long_description = "More description about your plan"
-# author = "Your Name Here"
-# email = "YourEmail@YourDomain"
-# copyright = "Vintage 2006 - a good year indeed"
-
-# if it's open source, you might want to specify these
-# url = "http://yourcool.site/"
-# download_url = "http://yourcool.site/download"
-# license = "MIT"
+version = "1.1.1-0.13"
+
+description = "Loggerhead is a web viewer for projects in bazaar."
+
+author = "Robey Pointer"
+email = "robey@lag.net"
+
+license = "GPL"
+url = "http://www.lag.net/loggerhead/"
+download_url = "http://www.lag.net/loggerhead/download/loggerhead-1.1.1-0.13.tar.gz"

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-15 08:42:22 +0000
+++ loggerhead/static/css/style.css	2007-01-24 19:17:40 +0000
@@ -10,30 +10,51 @@
 }
 
 a {
-	text-decoration: none;
-	color: #000088;
+    text-decoration: none;
+    color: #000088;
 }
 a:hover {
-	color: black;
+    color: black;
 }
 
 img {
-	border: none;
+    border: none;
 }
 
 h1 {
     color: #708a96;
-	font-weight: normal;
-	font-size: 1.6em;
+    font-weight: normal;
+    font-size: 1.6em;
     margin-bottom: 1.5em;
 }
 h1 .filename {
-	font-family: monospace;
+    font-family: monospace;
 }
 
 .branch-name {
-	color: #47626e;
-}
+    color: #47626e;
+}
+
+.footer {
+    margin-top: 1em;
+    margin-bottom: 1em;
+}
+.footer .banner {
+    margin-right: 5px;
+}
+.footer .banner img {
+    border: 1px solid #8cacbb;
+}
+
+.collapse-triangle {
+    padding-right: 0.5em;
+}
+
+.hide-all {
+    font-size: smaller;
+    padding: 0.25em 0.75em 0.25em 0.75em;
+}
+
 
 
 /* ----- navigation bar at the top ----- */
@@ -41,8 +62,14 @@
 .navbar {
 }
 
-.navbar table, .bar table {
-	width: 100%;
+.bar table {
+    width: 100%;
+    border-collapse: collapse;
+}
+
+/* safari gives forms a big default margin, to vex me */
+.bar form {
+    margin: 0px;
 }
 
 .bar {
@@ -56,12 +83,12 @@
 /* revision navigation buttons (the ones at the top right) */
 .navbuttons {
     padding: 2px;
-	bottom: 0px;
-	text-align: right;
-	width: auto;
-	border-left: 1px dotted #8cacbb;
-	padding-left: 0.5em;
-	padding-right: 0.5em;
+    bottom: 0px;
+    text-align: right;
+    width: auto;
+    border-left: 1px dotted #8cacbb;
+    padding-left: 0.5em;
+    padding-right: 0.5em;
 }
 
 .navbuttons a {
@@ -75,22 +102,11 @@
     color: blue;
 }
 
-/* the "changes: 425 / 425" header at the top right */
-.navposition {
-	margin-bottom: 1.5em;
-}
-
-.navposition table tr td {
-    margin-top: 0px;
-    font-weight: bold;
-    font-size: smaller;
-}
-
 /* navigation button in the pages (the ones at the top left, and bottom) */
 .buttons {
 }
 
-.buttons a {
+.buttons a,.buttons .search {
     font-weight: normal;
     color: #000088;
     font-size: 12pt;
@@ -105,7 +121,7 @@
 }
 
 .feed img {
-	vertical-align: text-top;
+    vertical-align: text-top;
 }
 
 .rbuttons a {
@@ -119,10 +135,11 @@
     width: auto;
 }
 
+
 /* ----- revision display in various places ----- */
 
 .revision .revno {
-	font-weight: bold;
+    font-weight: bold;
 }
 
 .revision .revid {
@@ -139,13 +156,13 @@
 /* ---- sub-links underneath the headline on some pages ----- */
 
 div.links {
-	padding-top: 0.5em;
-	padding-left: 3em;
-	font-size: 50%;
+    padding-top: 0.5em;
+    padding-left: 3em;
+    font-size: 50%;
 }
 
 div.links div {
-	margin-bottom: 3px;
+    margin-bottom: 3px;
 }
 
 
@@ -168,28 +185,24 @@
     vertical-align: top;
 
     padding-left: 0.5em;
-	padding-right: 0.5em;
-	padding-top: 2px;
-	padding-bottom: 2px;
+    padding-right: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
 }
 
 .info-entry td {
     font-weight: normal;
-  	padding-left: 0.5em;
-	padding-top: 2px;
-	padding-bottom: 2px;
+    padding-left: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
 }
 
 
 /* ----- changelog page ----- */
 
-.hide-all {
-	font-size: smaller;
-}
-
 /* secret css-jutsu to make hidden margins vanish on a table */
 .log-entries table {
-	border-collapse: collapse;
+    border-collapse: collapse;
     width: 100%;
 }
 
@@ -197,8 +210,8 @@
     background-color: #dee7ec;
     padding: 3px;
     width: 80%;
-	margin-top: 1em;
-	margin-left: 1em;
+    margin-top: 1em;
+    margin-left: 1em;
 }
 
 .log-entries .revision-header td.expand-button {
@@ -206,69 +219,69 @@
 }
 
 .log-entries .revision-header .revision-number {
-	width: 6em;
-	padding-left: 0.5em;
+    width: 6em;
+    padding-left: 0.5em;
 }
 
 .log-entries .revision-header .inventory-link {
-	font-size: smaller;
-	vertical-align: middle;
-	width: 4em;
-	text-align: right;
-	padding-right: 0.5em;
+    font-size: smaller;
+    vertical-align: middle;
+    width: 4em;
+    text-align: right;
+    padding-right: 0.5em;
 }
 
 .log-entries .revision-details-block {
-	width: 80%;
-	border: none;
-	margin-left: 8em;
-	margin-bottom: 1.5em;
+    width: 80%;
+    border: none;
+    margin-left: 8em;
+    margin-bottom: 1.5em;
 }
 
 .log-entries .revision-details table {
-	font-size: smaller;
-	width: 100%;
+    font-size: smaller;
+    width: 100%;
 }
 
 .log-entries .revision-details th {
-	width: 8em;
-	text-align: right;
-	padding-right: 0.5em;
-	vertical-align: top;
+    width: 8em;
+    text-align: right;
+    padding-right: 0.5em;
+    vertical-align: top;
 }
 
 .log-entries .revision-details td.date {
-/*	font-family: monospace; */
+/*    font-family: monospace; */
 }
 
 .log-entries .revision-details th.files {
-	padding-top: 1em;
+    padding-top: 1em;
 }
 
 .log-entries .revision-details td.files {
-	padding-top: 1em;
+    padding-top: 1em;
 }
 
 .log-entries .revision-details td.files .filename {
-	font-family: monospace;
+    font-family: monospace;
 }
 
-.log-entries .revision-details td.files a.jump {
+.log-entries .revision-details td.files .jump {
     font-size: smaller;
 }
 
 .log-entries .revision-details th.description {
-	padding-top: 1em;
+    padding-top: 1em;
 }
 .log-entries .revision-details td.description {
-	font-family: monospace;
-	padding-top: 1em;
+    font-family: monospace;
+    padding-top: 1em;
 }
 
 /* default state: hide all */
-.show-button { display: none; }
+.revision-header .hide-button { display: none; }
 .hidden-details { display: none; }
-.hide-all#hide-all { display: none; }
+.changelog .collapse-cl-hideall { display: none; }
 
 
 /* ----- revision page ----- */
@@ -285,46 +298,46 @@
 
 /* secret css-jutsu to make hidden margins vanish on a table */
 .revision-info table {
-	border-collapse: collapse;
+    border-collapse: collapse;
     width: 100%;
 }
 
 .revision-info th {
-	background-color: #dee7ec;
+    background-color: #dee7ec;
     color: black;
-	font-weight: normal;
-	text-align: right;
-	vertical-align: top;
-	
-	padding-left: 0.5em;
-	padding-right: 0.5em;
-	padding-top: 2px;
-	padding-bottom: 2px;
+    font-weight: normal;
+    text-align: right;
+    vertical-align: top;
+    
+    padding-left: 0.5em;
+    padding-right: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
 }
 
 .revision-info td {
-	font-weight: normal;
-  	padding-left: 0.5em;
-	padding-top: 2px;
-	padding-bottom: 2px;
+    font-weight: normal;
+    padding-left: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
 }
 
 .revision-info table td.date {
-	font-family: monospace;
+    font-family: monospace;
 }
 
 .revision-info table td.description {
-	font-family: monospace;
+    font-family: monospace;
 }
 
 .revision-info table td.files .filename {
-	font-family: monospace;
+    font-family: monospace;
 }
 
 .revision-info table td.files a.jump {
-	font-size: smaller;
+    font-size: smaller;
 }
-	
+    
 .revision-info table tr.divider {
     border-top: 1px solid #8cacbb;
 }
@@ -335,73 +348,128 @@
 .diff {
     margin-bottom: 1em;
     padding-top: 10px;
-    margin-top: 20px;
     width: 100%;
     background-color: #fcfcfc;
     font-family: monospace;
 }
 
-.diff-block,.diff-chunk {
-	border-collapse: collapse;
+
+.diff-block {
+    border-collapse: collapse;
     width: 100%;
+    margin-bottom: 1em;
 }
 
 .diff-block th.filename {
-	font-family: monospace;
-	font-weight: normal;
-	font-size: smaller;
-	padding-left: 1em;
-	padding-top: 1em;
-	padding-bottom: 1em;
-	text-align: left;
-	background-color: #dee7ec;
+    font-family: monospace;
+    font-weight: normal;
+    font-size: smaller;
+    padding-left: 1em;
+    padding-top: 1em;
+    padding-bottom: 1em;
+    text-align: left;
+    background-color: #dee7ec;
 }
 
-.diff-chunk {
+.diff-block .diff-chunk {
     font-size: 66%;
     margin-top: 0px;
-	margin-bottom: 1em;
+    margin-bottom: 2em;
 }
 
-.diff-chunk th.lineno {
-	font-weight: bold;
+.diff-block th.lineno {
+    font-weight: bold;
     border-bottom: 1px solid #8cacbb;
     border-top: 1px solid #dee7ec;
-    border-left: 1px solid #dee7ec;
-}
-.diff-chunk .insert {
-	background-color: #b0efb0;
-}
-.diff-chunk .delete {
-	background-color: #ffa0a0;
+}
+
+.diff-block .diff-spacing {
+    line-height: 1em;
+}
+
+.diff-option-buttons {
+    margin-top: 1.0em;
+    margin-bottom: 1.0em;
+    border-collapse: collapse;
+}
+.diff-option-buttons td {
+    line-height: 1em;
+    height: 1em;
+    vertical-align: middle;
+    padding: 0px;
+}
+.diff-option-buttons .label {
+    font-size: smaller;
+    padding-left: 0.75em;
+    padding-right: 2em;
+    line-height: 1em;
+}
+.diff-option-buttons .spacey {
+    padding-right: 5em;
+}
+
+.diff-option-buttons .collapse-file-showall { display: none; }
+
+.diff-block .show-button { display: none; }
+.diff .collapse-style-unified-content { display: none; }
+.collapse-style-sbs-show { display: none; }
+
+.diff-insert {
+    background-color: #9cc8ff;
+}
+.diff-delete {
+    background-color: #ffa0a0;
 }
 .diff-chunk td.text {
-	padding-left: 1em;
+    padding-left: 1em;
+}
+
+.diff-key {
+    display: inline;
+    font-size: smaller;
+}
+
+.diff-key-block {
+    width: 1em;
+    height: 1em;
+    border: 1px solid #8cacbb;
+}
+
+.diff-key .label {
+    padding-right: 2em;
 }
 
 .diff .lineno {
-	color: purple;
-	background-color: #dee7ec; 
-	width: 4em;
-	text-align: right;
-	padding-right: 3px;
-	border-bottom: 1px solid #8cacbb;
+    color: purple;
+    background-color: #dee7ec; 
+    width: 4em;
+    text-align: right;
+    padding-right: 3px;
+    border-bottom: 1px solid #8cacbb;
+}
+.diff .lineno-skip {
+    width: 4em;
+    background-color: #dee7ec;
 }
 .diff .info {
-	color: blue;
-	background-color: #dee7ec;
-	margin-top: 15px;
+    color: blue;
+    background-color: #dee7ec;
+    margin-top: 15px;
 }
+/*
+.diff-context-skip {
+    background-color: #dee7ec;
+}*/
 
 
 /* ----- file inventory ----- */
 
 .inventory-path {
-	margin-top: 2em;
+    margin-top: 2em;
 }
 
 table.inventory {
-	border-collapse: collapse;
+    border-collapse: collapse;
     width: 80%;
     font-size: smaller;
     margin-top: 1em;
@@ -409,20 +477,20 @@
 }
 
 table.inventory td {
-	padding-top: 3px;
-	padding-bottom: 3px;
-	vertical-align: middle;
+    padding-top: 3px;
+    padding-bottom: 3px;
+    vertical-align: middle;
 }
 
 table.inventory th {
     background-color: #8cacbb;
     padding-top: 3px;
     padding-bottom: 3px;
-	text-align: left;
+    text-align: left;
 }
 
 table.inventory th.permissions {
-	padding-left: 0.5em;
+    padding-left: 0.5em;
 }
 
 .parity0 { background-color: #dee7ec; }
@@ -430,24 +498,30 @@
 
 .inventory td.permissions {
     font-family: monospace;
-    width: 10em;
-	padding-left: 0.5em;
+    width: 9em;
+    padding-left: 0.5em;
 }
 
 .inventory td.filename {
     font-family: monospace;
 }
 
+.inventory td.size {
+	font-family: monospace;
+	font-size: smaller;
+	width: 5em;
+}
+
 .inventory td.revision {
     width: 8em;
     padding-right: 1.5em;
 }
 
 .inventory td.date {
-	font-family: monospace;
-	font-size: smaller;
-	width: 10em;
-	padding-right: 1.5em;
+    font-family: monospace;
+    font-size: smaller;
+    width: 10em;
+    padding-right: 1.5em;
 }
 
 .inventory td.changes-link {
@@ -455,6 +529,11 @@
     font-size: smaller;
 }
 
+.inventory td.download-link {
+    width: 8em;
+    font-size: smaller;
+}
+
 span.folder {
     font-family: monospace;
 }
@@ -463,36 +542,36 @@
 /* ----- file annotation ----- */
 
 .annotate-path {
-	font-family: monospace;
+    font-family: monospace;
 }
 
 .annotate table {
-	border-collapse: collapse;
+    border-collapse: collapse;
     width: 100%;
     font-size: 66%;
 }
 
 .annotate td {
-	padding-top: 2px;
-	padding-bottom: 2px;
-	vertical-align: bottom;
+    padding-top: 2px;
+    padding-bottom: 2px;
+    vertical-align: bottom;
 }
 
 .annotate td.lineno {
-	font-family: monospace;
-	text-align: right;
-	width: 4em;
-	padding-right: 5px;
-	font-weight: bold;
-	border-bottom: 1px solid #8cacbb;
+    font-family: monospace;
+    text-align: right;
+    width: 4em;
+    padding-right: 5px;
+    font-weight: bold;
+    border-bottom: 1px solid #8cacbb;
 }
 
 .annotate td.revno {
-	font-family: monospace;
-	text-align: right;
-	width: 8em;
-	padding-right: 5px;
-	border-right: 1px solid #8cacbb;
+    font-family: monospace;
+    text-align: right;
+    width: 8em;
+    padding-right: 5px;
+    border-right: 1px solid #8cacbb;
 }
 
 .annotate td.text {
@@ -504,7 +583,7 @@
     background-color: #8cacbb;
     padding-top: 3px;
     padding-bottom: 3px;
-	text-align: left;
+    text-align: left;
 }
 
 .annotate th.lineno {
@@ -517,5 +596,68 @@
 }
 
 .annotate th.text {
-	padding-left: 1em;
+    padding-left: 1em;
+}
+
+
+/* ----- top-level browse page ----- */
+
+.browse-project-name {
+    background-color: #dee7ec;
+    padding-top: 5px;
+    padding-bottom: 5px;
+    margin-left: 1em;
+    margin-right: 1em;
+    padding-left: 1em;
+    width: 90%;
+    font-weight: bold;
+}
+
+.browse-project-description {
+	padding-top: 1em;
+	padding-bottom: 1em;
+	margin-left: 2em;
+    width: 90%;
+}
+	
+.browse-view {
+	margin-top: 1em;
+	margin-bottom: 1em;
+	margin-left: 2em;
+}
+
+.browse-view table {
+    border-collapse: collapse;
+    width: 90%;
+    margin-bottom: 2em;
+}
+
+.browse-view table tr.heading {
+    background-color: #8cacbb;
+    border-bottom: solid 1px #8cacbb;
+    font-size: smaller;
+}
+
+.browse-view td,.browse-view th {
+	padding: 0.25em 0.5em 0.25em 0.5em;
+}
+
+.browse-view td.name {
+	width: 20%;
+}
+
+.browse-view td.last-update {
+	font-size: smaller;
+	width: 15%;
+}
+
+.browse-view td.url {
+	font-family: monospace;
+	font-size: smaller;
+	padding-left: 3em;
+	padding-top: 0px;
+}
+
+.browse-view td.feed {
+	width: 16px;
 }

=== added file 'loggerhead/static/images/bazaar-banner.png'
Binary files loggerhead/static/images/bazaar-banner.png and loggerhead/static/images/bazaar-banner.png differ
=== modified file 'loggerhead/static/images/favicon.ico'
Binary files loggerhead/static/images/favicon.ico and loggerhead/static/images/favicon.ico differ
=== added file 'loggerhead/static/images/loggerhead-banner.png'
Binary files loggerhead/static/images/loggerhead-banner.png and loggerhead/static/images/loggerhead-banner.png differ
=== added file 'loggerhead/static/images/nav-small-in.gif'
Binary files loggerhead/static/images/nav-small-in.gif and loggerhead/static/images/nav-small-in.gif differ
=== added file 'loggerhead/static/images/nav-small-out.gif'
Binary files loggerhead/static/images/nav-small-out.gif and loggerhead/static/images/nav-small-out.gif differ
=== added file 'loggerhead/static/javascript/collapse.js'
--- loggerhead/static/javascript/collapse.js	1970-01-01 00:00:00 +0000
+++ loggerhead/static/javascript/collapse.js	2007-01-14 01:24:15 +0000
@@ -0,0 +1,104 @@
+
+/* reusable implementation of expand/collapse buttons, used to show/hide
+ * "more detailed" sections of the page.
+ */
+
+
+var collapse_cache = new Object();
+var collapse_all_cache = new Object();
+
+function cacheElement(group, name, remainder, element) {
+    var g = collapse_cache[group];
+    if (typeof(g) == "undefined") {
+        g = new Object();
+        collapse_cache[group] = g;
+    }
+    var n = g[name];
+    if (typeof(n) == "undefined") {
+        n = new Array();
+        g[name] = n;
+    }
+    n.push(new Array(remainder, element));
+}
+
+function cacheAllElement(group, name, element) {
+    var g = collapse_all_cache[group];
+    if (typeof(g) == "undefined") {
+        g = new Array();
+        collapse_all_cache[group] = g;
+    }
+    g.push(new Array(name, element));
+}
+
+/*
+ * cache all the elements that have a collapse-<group>-<name>-* class on them.
+ * javascript can be very slow so this should make the UI more responsive.
+ */
+function sortCollapseElements() {
+    var elements = document.getElementsByTagName("*");
+    for (var i = 0; i < elements.length; i++) {
+        var classes = elements[i].className.split(' ');
+        for (var j = 0; j < classes.length; j++) {
+            if (classes[j].indexOf("collapse-") == 0) {
+                var segments = classes[j].split('-');
+                if (segments.length == 4) {
+                    cacheElement(segments[1], segments[2], segments[3], elements[i]);
+                }
+                if (segments.length == 3) {
+                    cacheAllElement(segments[1], segments[2], elements[i]);
+                }
+            }
+        }
+    }
+}
+
+
+function collapseContent(group, name) {
+    return 'collapse-' + group + '-' + name + '-content';
+}
+
+function collapseDisplay(group, name, display) {
+    // display mode for the disclosure triangles:
+    var dthide = 'inline', dtshow = 'none';
+    if (display == 'none') { dthide = 'none'; dtshow = 'inline'; }
+
+    var elements = collapse_cache[group][name];
+    for (var i in elements) {
+        var kind = elements[i][0], node = elements[i][1];
+        if (kind == "show") {
+            node.style.display = dtshow;
+        } else if (kind == "hide") {
+            node.style.display = dthide;
+        } else if (kind == "content") {
+            node.style.display = display;
+        }
+    }
+}
+
+function collapseAllDisplay(group, display) {
+    for (var name in collapse_cache[group]) {
+        collapseDisplay(group, name, display);
+    }
+    
+    var dthide = 'inline', dtshow = 'none';
+    if (display == 'none') { dthide = 'none'; dtshow = 'inline'; }
+    for (var element in collapse_all_cache[group]) {
+        var x = collapse_all_cache[group][element];
+        var name = x[0], node = x[1];
+        if (name == "showall") {
+            node.style.display = dtshow;
+        } else if (name == "hideall") {
+            node.style.display = dthide;
+        }
+    }
+}
+
+
+// for debugging
+function debug(s) {
+    var d = new Date();
+    var hh = d.getHours(), mm = d.getMinutes(), ss = d.getSeconds(), ms = d.getMilliseconds();
+    var ds = ((hh < 10) ? "0" + hh : hh) + ":" + ((mm < 10) ? "0" + mm : mm) + ":" + ((ss < 10) ? "0" + ss : ss) + "." + ((ms < 10) ? "00" + ms : ((ms < 100) ? "0" + ms : ms));
+    console.log("[" + ds + "] " + s);
+}
+

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/annotate.kid	2007-01-21 00:05:52 +0000
@@ -3,56 +3,22 @@
     py:extends="'master.kid'">
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch_name} : contents of ${path} at revision ${change.revno} </title>
+    <title> ${branch.friendly_name} : contents of ${path} at revision ${change.revno} </title>
 </head>
 
 <body>
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : <span class="annotate-path">${path}</span> (revision ${change.revno})
+<h1> <span class="branch-name">${branch.friendly_name}</span> : <span class="annotate-path">${path}</span> (revision ${change.revno})
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url([ '/files', revid ])}"> browse files </a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/revision', start_revid=revid)}"> view revision </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
 	</div>
 </h1>
 
-<!-- !FIXME: this is just copied verbatim from revision.kid -->
-<!--div class="revision-info">
-    <table>
-        <tr>
-            <th class="author">committed by:</th>
-            <td class="author"> ${util.hide_email(change.author)} </td>
-        </tr>
-        <tr>
-            <th class="date">date:</th>
-            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
-        </tr>
-
-        <tr py:if="len(change.merge_points) > 0">
-            <th class="children"> merged in: </th>
-            <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp;
-                </span>
-            </td>
-        </tr>
-        <tr py:if="len(change.parents) > 1">
-        	<th class="parents"> merged from: </th>
-        	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-           	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
-                </span></span>
-        	</td>
-        </tr>
-
-        <tr>
-            <th class="description">description:</th>
-            <td class="description"><span py:for="line in change.comment_clean">${XML(line)} <br /></span></td>
-        </tr>
-    </table>
-</div-->
-
 <div class="annotate">
     <table>
         <tr>
@@ -64,10 +30,9 @@
         <tr py:for="line in contents" class="parity${line.parity}">
             <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${tg.url('/revision', start_revid=line.change.revid, path=path)}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${line.trunc_revno}</a>
+                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
-            <!--td class="author"> ${util.hide_email(line.author)} </td-->
             <td class="text ${line.status}"> ${XML(line.text)} </td>
         </tr>
     </table>

=== modified file 'loggerhead/templates/atom.kid'
--- loggerhead/templates/atom.kid	2006-12-11 06:44:19 +0000
+++ loggerhead/templates/atom.kid	2006-12-20 21:24:32 +0000
@@ -1,18 +1,18 @@
 <?xml version="1.0" encoding="utf-8"?>
 <feed xmlns="http://www.w3.org/2005/Atom" xmlns:py="http://purl.org/kid/ns#">
-    <title> bazaar changes for ${branch_name} </title>
+    <title> bazaar changes for ${branch.friendly_name} </title>
     <updated>${updated}</updated>
-    <id>${tg.url([ external_url, 'atom' ])}</id>
-    <link rel="self" href="${tg.url([ external_url, 'atom' ])}" />
+    <id>${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}</id>
+    <link rel="self" href="${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}" />
 
 	<entry py:for="entry in changes">
-	    <title> ${entry.short_comment} </title>
-	    <updated> ${entry.date.isoformat() + 'Z'} </updated>
-	    <id>${tg.url([ external_url, 'atom', entry.revid ])}</id>
+	    <title> ${entry.revno}: ${entry.short_comment} </title>
+	    <updated>${entry.date.isoformat() + 'Z'}</updated>
+	    <id>${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}</id>
 	    <author> <name> ${util.hide_email(entry.author)} </name> </author>
 	    <content type="text">
             ${entry.comment}
 	    </content>
-	    <link rel="alternate" href="${tg.url([ external_url, 'revision', entry.revid ])}" />
+	    <link rel="alternate" href="${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}" />
 	</entry>
 </feed>

=== added file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/browse.kid	2007-01-21 00:05:52 +0000
@@ -0,0 +1,55 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
+    py:extends="'master.kid'">
+<head>
+    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
+    <title> loggerhead branches </title>
+</head>
+
+<body>
+
+<h1>
+    <span py:if="title">${title}</span>
+    <span py:if="not title"> bazaar branches in loggerhead </span>
+</h1>
+
+<div class="browse-project" py:for="project in projects">
+    <div class="browse-project-name">
+        ${project.friendly_name}
+    </div>
+    
+    <div class="browse-project-description" py:if="len(project.long_description) > 0">
+    ${XML(project.long_description)}
+    </div>
+    
+    <div class="browse-view">
+        <table>
+        <tr class="heading">
+            <th> Name </th>
+            <th> Description </th>
+            <th> Last change </th>
+            <th />
+        </tr>
+        <span py:for="view in project.views">
+            <tr>
+            <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
+            <td class="description"> ${view.description} </td>
+            <td class="last-update"> ${util.ago(view.last_updated())} </td>
+            <td class="feed">
+                <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
+                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />
+                </a>
+            </td>
+            </tr>
+            <tr py:if="view.branch_url is not None">
+                <td class="name"> </td>
+                <td class="description url" colspan="2"> <a href="${view.branch_url}">${view.branch_url}</a> </td>
+            </tr>
+        </span>
+        </table>
+    </div>
+
+</div>
+
+</body>
+</html>

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/changelog.kid	2007-01-21 00:05:52 +0000
@@ -3,59 +3,35 @@
     py:extends="'master.kid'">
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch_name} : changes </title>
-    <link rel="alternate" type="application/atom+xml" href="${tg.url('/atom')}" title="RSS feed for ${branch_name}" />
+    <title> ${branch.friendly_name} : changes </title>
+    <link rel="alternate" type="application/atom+xml" href="${branch.url('/atom')}" title="RSS feed for ${branch.friendly_name}" />
     
     <span py:def="loglink(revid, text)">
-        <a title="Show history" href="${tg.url('/changes', start_revid=revid)}" class="revlink"> ${text} </a>
-    </span>
-
-    <span py:def="file_link(filename, revid)">
-        <a href="${tg.url([ '/annotate', revid ], path=filename)}" title="Annotate ${filename}">${filename}</a>
-    </span>
-
-    <!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-    <script type="text/javascript"> // <!--
-    function displayDetails(name, hide, show) {
-        if (show == '') { show = 'inline'; }
-        var bhide = hide, ihide = hide;
-        if (hide == '') { bhide = 'block'; ihide = 'inline'; }
-        document.getElementById('details-' + name).style.display = bhide;
-        document.getElementById('hide-' + name).style.display = ihide;
-        document.getElementById('show-' + name).style.display = show;
-    }
-    function displayAll(hide, show) {
-        if (show == '') { show = 'inline'; }
-        var bhide = hide, ihide = hide;
-        if (hide == '') { bhide = 'block'; ihide = 'inline'; }
-        var nodes = document.getElementsByTagName('div');
-        for (var i = 0; i < nodes.length; i++) {
-            var id = nodes[i].id;
-            if ((id.length > 8) && (id.substring(0, 8) == 'details-')) {
-                nodes[i].style.display = bhide;
-                var revno = id.substring(8);
-                document.getElementById('hide-' + revno).style.display = ihide;
-                document.getElementById('show-' + revno).style.display = show;
-            }
-        }
-        document.getElementById('hide-all').style.display = ihide;
-        document.getElementById('show-all').style.display = show;
-    }
-    // -->
-	</script>
+        <a title="Show history" href="${branch.url('/changes', **util.get_context(start_revid=revid))}" class="revlink"> ${text} </a>
+    </span>
+
+    <span py:def="file_link(filename, file_id, revid)">
+        <a href="${branch.url([ '/annotate', revid ], **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
+    </span>
+    
+    ${use_collapse_buttons()}
 </head>
 
-<body>
+<body onload="javascript:sortCollapseElements();">
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : changes
-<span py:if="path"> to <span class="filename">${path}</span></span>
-<span py:if="last_revid != start_revid"> from ${history.get_revno(start_revid)} </span>
+<h1> <span class="branch-name">${branch.friendly_name}</span> : changes
+<span py:if="file_id"> to <span class="filename">${history.get_path(revid, file_id)}</span></span>
+<span py:if="viewing_from"> from ${history.get_revno(start_revid)} </span>
+<span py:if="query"> matching "${query}"</span>
 </h1>
 
-<a class="hide-all" id="hide-all" href="javascript:displayAll('none', '')"> (hide all) </a>
-<a class="hide-all" id="show-all" href="javascript:displayAll('', 'none')"> (show all) </a>
+<span py:if="search_failed">
+    Sorry, no results found for your search.
+</span>
+
+<span py:if="not search_failed" class="changelog"> ${collapse_all_button('cl')} </span>
 
 <div class="log-entries">
     <div py:for="entry in changes" class="revision">
@@ -63,17 +39,10 @@
         <div class="revision-header">
             <table>
                 <tr>
-                    <td class="revision-number"> ${revlink_path(entry.revid, start_revid, entry.revno, path)} </td>
-                    <td class="expand-button">
-                        <a href="javascript:displayDetails('${entry.revno}', 'none', '')" id="hide-${entry.revno}" class="show-button">
-                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" />
-                        </a>
-                        <a href="javascript:displayDetails('${entry.revno}', '', 'none')" id="show-${entry.revno}" class="hide-button">
-                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" />
-                        </a>
-                    </td>
-					<td class="summary"> ${revlink_path(entry.revid, start_revid, entry.short_comment, path)} </td>
-					<td class="inventory-link"> <a href="${tg.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
+                    <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
+                    <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
+					<td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
+					<td class="inventory-link"> <a href="${branch.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
 				</tr>
 			</table>
         </div>
@@ -91,13 +60,13 @@
 			        </tr>
 			    </table>
 			</div>
-	        <div class="revision-details hidden-details" id="details-${entry.revno}">
+	        <div class="revision-details hidden-details collapse-cl-${entry.revno}-content">
 		        <table>
 			        <tr py:if="len(entry.merge_points) > 0">
 			            <th class="children"> merged in: </th>
 			            <td class="children">
 			                <span py:for="child in entry.merge_points">
-			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} &nbsp; 
+			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
 			                </span>
 			            </td>
 			        </tr>
@@ -105,30 +74,30 @@
 			        	<th class="parents"> merged from: </th>
 			        	<td class="parents">
 			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
-			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} &nbsp;
+			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
 			        	    </span></span>
 			        	</td>
 			        </tr>
 
 			        <tr py:if="entry.changes.added">
 			            <th class="files"> files added: </th>
-			            <td class="files"> <span py:for="filename in entry.changes.added" class="filename">${file_link(filename, entry.revid)} <br /></span> </td>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.removed">
 			            <th class="files"> files removed: </th>
-			            <td class="files"> <span py:for="filename in entry.changes.removed" class="filename">${file_link(filename, entry.revid)} <br /></span> </td>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.renamed">
 			            <th class="files"> files renamed: </th>
-			            <td class="files"> <span py:for="old_filename, new_filename in entry.changes.renamed" class="filename">
-			                ${file_link(old_filename, entry.revid)} => ${file_link(new_filename, entry.revid)}<br />
+			            <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
+			                ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
 			            </span> </td>
 			        </tr>
 			        <tr py:if="entry.changes.modified">
 			            <th class="files"> files modified: </th>
 			            <td class="files"> <span py:for="item in entry.changes.modified">
-			                <span class="filename">${file_link(item.filename, entry.revid)}</span> &nbsp;
-			                <a href="${tg.url([ '/revision', entry.revid ], start_revid=start_revid, path=path) + '#' + item.filename}" class="jump">(jump to diff)</a>
+			                <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
+			                <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
 			                <br />
 			            </span> </td>
 			        </tr>
@@ -142,7 +111,7 @@
     </div>
 </div>
 
-<div class="bar">
+<div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
     <table>
         <tr>
         	<td class="buttons">

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/inventory.kid	2007-01-24 19:26:50 +0000
@@ -3,17 +3,19 @@
     py:extends="'master.kid'">
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch_name} : files for revision ${change.revno} </title>
+    <title> ${branch.friendly_name} : files for revision ${change.revno} </title>
 </head>
 
 <body>
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : files for revision ${change.revno}
+<h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url('/revision', start_revid=revid)}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/changes', start_revid=revid)}"> view branch changes </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}">
+	        view revision </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid))}">
+	        view branch changes </a> </div>
 	</div>
 </h1>
 
@@ -33,7 +35,7 @@
             <th class="children"> merged in: </th>
             <td class="children">
                 <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp; 
+                    ${revision_link(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', clear=1, start_revid=child.revid)} <br />
                 </span>
             </td>
         </tr>
@@ -41,7 +43,7 @@
         	<th class="parents"> merged from: </th>
         	<td class="parents">
         	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
+        	        ${revision_link(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', clear=1, start_revid=parent.revid)} <br />
         	    </span></span>
         	</td>
         </tr>
@@ -60,28 +62,40 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> Filename </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
         <th> Last change </th>
-        <th> When </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">When</a> </th>
         <th> History </th>
+        <th> Download </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${tg.url([ '/files', revid ], path=updir)}"> (up) </a></td>
-        <td> </td> <td> </td> <td> </td>
+        <td class="filename directory"><a href="${branch.url([ '/files', revid ],
+            **util.get_context(file_id=updir_file_id))}"> (up) </a></td>
+        <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
         <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
         <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${tg.url([ '/files', revid ], path=posixpath.join(path, file.pathname))}">${file.filename}/</a>
+            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ],
+                **util.get_context(file_id=file.file_id))}">${file.filename}/</a>
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${tg.url([ '/annotate', revid ], path=posixpath.join(path, file.pathname))}">${file.filename}</a>
+            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
+                **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
-        <td class="revision"> ${revlink_path(file.revid, file.revid, util.trunc(file.change.revno, 15), posixpath.join(path, file.pathname))} </td>
+        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
+        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
         <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
-        <td class="changes-link"> <a href="${tg.url('/changes', start_revid=file.revid, path=posixpath.join(path, file.pathname))}"> &#8594; changes </a></td>
+        <td class="changes-link"> 
+            <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
+               title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
+        </td>
+        <td class="download-link">
+            <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"
+               title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
     </tr>
 </table>
 

=== removed file 'loggerhead/templates/login.kid'
--- loggerhead/templates/login.kid	2006-12-11 06:44:19 +0000
+++ loggerhead/templates/login.kid	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml"
-    xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-
-<head>
-    <meta content="text/html; charset=UTF-8"
-        http-equiv="content-type" py:replace="''"/>
-    <title>Login</title>
-    <style type="text/css">
-        #loginBox
-        {
-            width: 30%;
-            margin: auto;
-            margin-top: 10%;
-            padding-left: 10%;
-            padding-right: 10%;
-            padding-top: 5%;
-            padding-bottom: 5%;
-            font-family: verdana;
-            font-size: 10px;
-            background-color: #eee;
-            border: 2px solid #ccc;
-        }
-
-        #loginBox h1
-        {
-            font-size: 42px;
-            font-family: "Trebuchet MS";
-            margin: 0;
-            color: #ddd;
-        }
-
-        #loginBox p
-        {
-            position: relative;
-            top: -1.5em;
-            padding-left: 4em;
-            font-size: 12px;
-            margin: 0;
-            color: #666;
-        }
-
-        #loginBox table
-        {
-            table-layout: fixed;
-            border-spacing: 0;
-            width: 100%;
-        }
-
-        #loginBox td.label
-        {
-            width: 33%;
-            text-align: right;
-        }
-
-        #loginBox td.field
-        {
-            width: 66%;
-        }
-
-        #loginBox td.field input
-        {
-            width: 100%;
-        }
-
-        #loginBox td.buttons
-        {
-            text-align: right;
-        }
-
-    </style>
-</head>
-
-<body>
-    <div id="loginBox">
-        <h1>Login</h1>
-        <p>${message}</p>
-        <form action="${previous_url}" method="POST">
-            <table>
-                <tr>
-                    <td class="label">
-                        <label for="user_name">User Name:</label>
-                    </td>
-                    <td class="field">
-                        <input type="text" id="user_name" name="user_name"/>
-                    </td>
-                </tr>
-                <tr>
-                    <td class="label">
-                        <label for="password">Password:</label>
-                    </td>
-                    <td class="field">
-                        <input type="password" id="password" name="password"/>
-                    </td>
-                </tr>
-                <tr>
-                    <td colspan="2" class="buttons">
-                        <input type="submit" name="login" value="Login"/>
-                    </td>
-                </tr>
-            </table>
-
-            <input py:if="forward_url" type="hidden" name="forward_url"
-                value="${forward_url}"/>
-                
-            <input py:for="name,value in original_parameters.items()"
-                type="hidden" name="${name}" value="${value}"/>
-        </form>
-    </div>
-</body>
-</html>

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2006-12-15 10:11:30 +0000
+++ loggerhead/templates/master.kid	2007-01-24 19:17:40 +0000
@@ -11,48 +11,97 @@
     </style>
 
 <!-- !define common navbar -->
-<span py:def="navbar()">
-    <!-- !requires: ${navigation: start_revid, revid, revlist, pagesize, buttons, scan_url}, ${history} -->
-    <div class="navbar">
-        <div class="bar">
-            <table>
-                <tr><td>
-                    <span class="buttons">
-                        <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                        <a href="${tg.url('/changes')}"> changes </a>
-                        <a href="${tg.url('/files')}"> files </a>
-                    </span>
-                </td><td align="right" py:if="hasattr(navigation, 'revlist')">
-                    <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
-                        <a href="${tg.url('/atom')}"><img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                    </span>
-                    <span class="navbuttons">
-                    	<span py:if="navigation.prev_page_revid"> <a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>	</span>
-                    	<span py:if="not navigation.prev_page_revid"> &#171; </span>
-                        	revision ${history.get_revno(revid)} (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
-                    	<span py:if="navigation.next_page_revid"> <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>	</span>
-                    	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                    </span>
-                </td></tr>
-            </table>
-        </div>
+<span py:def="navbar()" py:strip="True">
+    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
+    <div class="bar" py:if="navigation is not None">
+        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
+        <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
+              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
+            <td><span class="buttons">
+                <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
+                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
+                <span class="search"> search: <input type="text" name="q" /> </span>
+            </span></td>
+            <td align="right" py:if="hasattr(navigation, 'revid_list')">
+                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+                    <a href="${branch.url('/atom')}">
+                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
+                </span>
+                <span class="navbuttons">
+                	<span py:if="navigation.prev_page_revid">
+                	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
+                    </span>
+                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
+                    revision ${history.get_revno(revid)}
+                    (<span py:if="navigation.pagesize > 1">page </span>
+                    ${navigation.page_position} / ${navigation.page_count})
+                	<span py:if="navigation.next_page_revid">
+                    <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
+                    </span>
+                	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                </span>
+            </td>
+        </tr></table></form>
     </div>
 </span>
 
-<span py:def="revlink(revid, text)">
-    <a title="Show revision" href="${tg.url([ '/revision', revid ])}" class="revlink"> ${text} </a>
-</span>
-<span py:def="revlink_path(revid, start_revid, text, path)">
-    <a title="Show revision" href="${tg.url([ '/revision', revid ], start_revid=start_revid, path=path)}" class="revlink"> ${text} </a>
-</span>
+<span py:def="revision_link(revid, text, **overrides)" py:strip="True">
+    <a title="Show revision ${history.get_revno(revid)}"
+       href="${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"> ${text} </a>
+</span>
+
+
+<!-- ! expand button functions: -->
+
+	<span py:strip="True" py:def="use_collapse_buttons()">
+		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
+		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
+	    <a class="hide-all collapse-${group}-hideall"
+	       href="javascript:collapseAllDisplay('${group}','none')">
+	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
+	             width="10" height="10" alt="collapse"
+	             class="collapse-triangle" />collapse all</a>
+	    <a class="hide-all collapse-${group}-showall"
+	       href="javascript:collapseAllDisplay('${group}','${normal}')">
+	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
+	             width="10" height="10" alt="expand"
+	             class="collapse-triangle" />expand all</a>
+	</span>
+	
+	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
+	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
+	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
+	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
+	             width="10" height="10" alt="collapse"
+	             class="collapse-triangle" />
+	    </a>
+	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
+	       class="show-button collapse-${group}-${name}-show" title="expand">
+	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
+	    	     witdh="10" height="10" alt="expand"
+	    	     class="collapse-triangle" />
+	    </a>
+	</span>
 
 </head>
 
-<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'" py:attrs="item.items()">
+<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
+      py:attrs="item.items()">
 
     <div py:replace="[item.text]+item[:]"/>
 
 	<!-- End of main_content -->
+	
+	<div class="footer">
+	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
+	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
+	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
+	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
+	</div>
 </body>
 
 </html>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-15 08:42:22 +0000
+++ loggerhead/templates/revision.kid	2007-01-24 19:26:50 +0000
@@ -3,22 +3,69 @@
     py:extends="'master.kid'">
 <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch_name} : revision ${change.revno} </title>
+    <title> ${branch.friendly_name} : revision ${change.revno} </title>
     
-    <span py:def="file_link(filename)">
-        <a href="${tg.url([ '/annotate', revid ], path=filename)}" title="Annotate ${filename}">${filename}</a>
+    <span py:strip="True" py:def="file_link(filename, file_id)">
+        <a href="${branch.url([ '/annotate', revid ],
+            **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
+    
+    <span py:replace="use_collapse_buttons()"></span>
+    
+    <script type="text/javascript"> <!--
+    function show_sbs() {
+        collapseDisplay('style', 'sbs', 'table');
+        collapseDisplay('style', 'unified', 'none');
+        document.cookie='diff=sbs';
+    }
+    function show_unified() {
+        collapseDisplay('style', 'unified', 'table');
+        collapseDisplay('style', 'sbs', 'none');
+        document.cookie='diff=unified'; 
+    }
+    function load() {
+        sortCollapseElements();
+        if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
+    }
+    // --> </script>
 </head>
 
-<body>
+<body onload="javascript:load()">
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno}
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${tg.url([ '/files', revid ])}">browse files</a> </div>
-	    <div> <b>&#8594;</b> <a href="${tg.url('/changes', start_revid=revid)}">view branch changes</a> </div>
-	</div>
+<h1> <span class="branch-name">${branch.friendly_name}</span> : revision ${change.revno}
+    <span py:if="compare_revid is not None"> (compared to revision ${history.get_revno(compare_revid)}) </span>
+    
+    <div class="links">
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context())}">
+            browse files</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(start_revid=revid))}">
+            view branch changes</a> </div>
+        <span py:if="compare_revid is None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">
+                view/download patch</a> </div>
+        </span>
+        <span py:if="compare_revid is not None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, compare_revid, 'bundle.txt' ])}">
+                view/download patch</a> </div>
+        </span>
+        <span py:if="(remember is not None) and (compare_revid is None)" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(compare_revid=remember))}">
+                compare with revision ${history.get_revno(remember)} </a></div>
+        </span>
+        <span py:if="remember != revid" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=revid, compare_revid=None))}">
+                compare with another revision </a></div>
+        </span>
+        <span py:if="compare_revid is not None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=None, compare_revid=None))}">
+                stop comparing to revision ${history.get_revno(compare_revid)} </a></div>
+        </span>
+    </div>
 </h1>
  
 <div class="revision-info">
@@ -36,7 +83,7 @@
             <th class="children"> merged in: </th>
             <td class="children">
                 <span py:for="child in change.merge_points">
-                    ${revlink_path(child.revid, child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', None)} &nbsp; 
+                    ${revision_link(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', clear=1, start_revid=child.revid)} <br /> 
                 </span>
             </td>
         </tr>
@@ -44,7 +91,7 @@
         	<th class="parents"> merged from: </th>
         	<td class="parents">
         	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink_path(parent.revid, parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', None)} &nbsp;
+        	        ${revision_link(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', clear=1, start_revid=parent.revid)} <br />
         	    </span></span>
         	</td>
         </tr>
@@ -58,54 +105,122 @@
         
         <tr py:if="change.changes.added">
             <th class="files"> files added: </th>
-            <td class="files"> <span py:for="filename in change.changes.added" class="filename">${file_link(filename)} <br /></span> </td>
+            <td class="files"> <span py:for="filename, file_id in change.changes.added" class="filename">${file_link(filename, file_id)} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.removed">
             <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename in change.changes.removed" class="filename">${file_link(filename)} <br /></span> </td>
+            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">${file_link(filename, file_id)} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.renamed">
             <th class="files"> files renamed: </th>
-            <td class="files"> <span py:for="old_filename, new_filename in change.changes.renamed" class="filename">${file_link(old_filename)} => ${file_link(new_filename)}<br /></span> </td>
+            <td class="files"> <span py:for="old_filename, new_filename, file_id in change.changes.renamed" class="filename">
+                ${file_link(old_filename, file_id)} => ${file_link(new_filename, file_id)}<br />
+            </span> </td>
         </tr>
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
                 <span py:for="item in change.changes.modified">
-                    <span class="filename">${file_link(item.filename)}</span> &nbsp; <a href="#${item.filename}" class="jump">(jump to diff)</a><br />
+                    <span class="filename">${file_link(item.filename, item.file_id)}</span> &nbsp; <a href="#${item.filename}" class="jump">&#8594; diff</a><br />
                 </span>
             </td>
         </tr>
     </table>
 </div>
 
+<table class="diff-option-buttons">
+<tr>
+    <td> ${collapse_all_button('file', 'table-row')} </td>
+
+    <td class="spacey">
+        <a href="javascript:show_sbs()" class="hide-all collapse-style-sbs-show" title="collapse">
+            <img src="${tg.url('/static/images/nav-small-out.gif')}" width="22" height="10" class="collapse-triangle" />show side by side</a>
+        <a href="javascript:show_unified()" class="hide-all collapse-style-unified-show" title="expand">
+            <img src="${tg.url('/static/images/nav-small-in.gif')}" width="22" height="10" class="collapse-triangle" />show unified diff</a>
+    </td>
+    
+    <td class="diff-key-block diff-insert"></td>
+    <td class="label"> added </td>
+    <td class="diff-key-block diff-delete"></td>
+    <td class="label"> removed</td>
+</tr>
+</table>
+
+<!-- ! i'm not a big fan of embedding python code here, but the alternatives all seem to be worse -->
+<?python uniqs={}; ?>
+
 <div class="diff" py:if="change.changes.modified">
-    <table py:for="item in change.changes.modified" class="diff-block">
-        <tr><th class="filename"> <a href="${tg.url([ '/annotate', change.revid ], path=item.filename)}" name="${item.filename}">${item.filename}</a> </th></tr>
-        <tr><td>
-            <table py:for="chunk in item.chunks" class="diff-chunk">
-                <tr> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> </tr>
-                <tr py:for="line in chunk.diff">
-                    <td class="lineno">${line.old_lineno}</td>
-                    <td class="lineno">${line.new_lineno}</td>
-                    <td class="${line.type} text">${XML(line.line)}</td>
-                </tr>
-            </table>
-        </td></tr>
-    </table>
+    <!-- ! side-by-side diff -->
+    <table class="diff-block collapse-style-sbs-content">
+        <span py:strip="True" py:for="item in change.changes.modified">
+            <tr><th class="filename" colspan="4">
+                ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
+                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+            </th></tr>
+
+            <span py:strip="True" py:for="chunk in item.sbs_chunks">
+                <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
+                    <th class="lineno">old</th> <th></th> <th class="lineno">new</th> <th></th>
+                </tr>
+                <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
+                    <span py:if="line.old_lineno" py:strip="True">
+                        <td class="lineno">${line.old_lineno}</td>
+                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
+                    </span>
+                    <span py:if="not line.old_lineno" py:strip="True">
+                        <td class="lineno-skip">${line.old_lineno}</td>
+                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
+                    </span>
+                    <span py:if="line.new_lineno" py:strip="True">
+                        <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
+                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
+                    </span>
+                    <span py:if="not line.new_lineno" py:strip="True">
+                        <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
+                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
+                    </span>
+                </tr>
+                <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
+            </span>
+            <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
+        </span>
+    </table>
+    
+    <!-- ! unified diff -->
+    <table class="diff-block collapse-style-unified-content">
+	    <span py:strip="True" py:for="item in change.changes.modified">
+	        <tr><th class="filename" colspan="4">
+	            ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
+	            <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+	        </th></tr>
+	
+	        <span py:strip="True" py:for="chunk in item.chunks">
+	            <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
+	            <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
+	                <td class="lineno">${line.old_lineno}</td>
+	                <td class="lineno">${line.new_lineno}</td>
+	                <td class="diff-${line.type} text">${XML(line.line)}</td>
+	                <td> </td>
+	            </tr>
+	            <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
+	        </span>
+	        <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
+	    </span>
+    </table>
+
 </div>
 
-<div class="bar">
+<div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
     <table>
         <tr>
-        	<td class="buttons">
-            	<a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt; revision ${history.get_revno(navigation.prev_page_revid)} </a>
-	 		</td>
- 			<td class="rbuttons" align="right">
-            	<a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> revision ${history.get_revno(navigation.next_page_revid)} &gt; </a>
- 			</td>
- 		</tr>
- 	</table>
+        <td class="buttons">
+            <a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt; revision ${history.get_revno(navigation.prev_page_revid)} </a>
+        </td>
+        <td class="rbuttons" align="right">
+            <a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> revision ${history.get_revno(navigation.next_page_revid)} &gt; </a>
+        </td>
+	</tr>
+    </table>
 </div>
 
 </body>

=== removed file 'loggerhead/templates/welcome.kid'
--- loggerhead/templates/welcome.kid	2006-12-11 06:44:19 +0000
+++ loggerhead/templates/welcome.kid	1970-01-01 00:00:00 +0000
@@ -1,50 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-<meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-<title>Welcome to TurboGears</title>
-</head>
-<body>
-<div id="header">&nbsp;</div>
-<div id="main_content">
-  <div id="status_block">Your TurboGears application is now running.</div>
-  <!--h1>Take steps to dive right in:</h1-->
-  <div id="sidebar">
-    <h2>Learn more</h2>
-    Learn more about TurboGears and take part in its
-    development
-    <ul class="links">
-      <li><a href="http://www.turbogears.org">Official website</a></li>
-      <li><a href="http://docs.turbogears.org">Documentation</a></li>
-      <li><a href="http://trac.turbogears.org/turbogears/">Trac
-        (bugs/suggestions)</a></li>
-      <li><a href="http://groups.google.com/group/turbogears"> Mailing list</a> </li>
-    </ul>
-  </div>
-  <div id="getting_started">
-    <ol id="getting_started_steps">
-      <li class="getting_started">
-        <h3>Model</h3>
-        <p> <a href="http://docs.turbogears.org/1.0/GettingStarted/DefineDatabase">Design models</a> in the <span class="code">model.py</span>.<br/>
-          Edit <span class="code">dev.cfg</span> to <a href="http://docs.turbogears.org/1.0/GettingStarted/UseDatabase">use a different backend</a>, or start with a pre-configured SQLite database. <br/>
-          Use script <span class="code">tg-admin sql create</span> to create the database tables.</p>
-      </li>
-      <li class="getting_started">
-        <h3>View</h3>
-        <p> Edit <a href="http://docs.turbogears.org/1.0/GettingStarted/Kid">html-like templates</a> in the <span class="code">/templates</span> folder;<br/>
-        Put all <a href="http://docs.turbogears.org/1.0/StaticFiles">static contents</a> in the <span class="code">/static</span> folder. </p>
-      </li>
-      <li class="getting_started">
-        <h3>Controller</h3>
-        <p> Edit <span class="code"> controllers.py</span> and <a href="http://docs.turbogears.org/1.0/GettingStarted/CherryPy">build your
-          website structure</a> with the simplicity of Python objects. <br/>
-          TurboGears will automatically reload itself when you modify your project. </p>
-      </li>
-    </ol>
-    <div class="notice"> If you create something cool, please <a href="http://groups.google.com/group/turbogears">let people know</a>, and consider contributing something back to the <a href="http://groups.google.com/group/turbogears">community</a>.</div>
-  </div>
-  <!-- End of getting_started -->
-</div>
-</body>
-</html>

=== added file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	1970-01-01 00:00:00 +0000
+++ loggerhead/textindex.py	2007-01-02 07:14:03 +0000
@@ -0,0 +1,233 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+"""
+indexing of the comment text of revisions, for fast searching.
+
+two separate 'shelve' files are created:
+
+    - recorded: revid -> 1 (if the revid is indexed)
+    - index: 3-letter substring -> list(revids)
+"""
+
+import logging
+import os
+import re
+import shelve
+import threading
+import time
+
+from loggerhead import util
+from loggerhead.util import decorator
+from loggerhead.lockfile import LockFile
+
+# if any substring index reaches this many revids, replace the entry with
+# an ALL marker -- it's not worth an explicit index.
+ALL_THRESHOLD = 1000
+ALL = 'ALL'
+
+
+with_lock = util.with_lock('_lock')
+
+
+def normalize_string(s):
+    """
+    remove any punctuation and normalize all whitespace to a single space.
+    """
+    s = util.to_utf8(s).lower()
+    # remove apostrophes completely.
+    s = re.sub(r"'", '', s)
+    # convert other garbage into space
+    s = re.sub(r'[^\w\d]', ' ', s)
+    # compress multiple spaces into one.
+    s = re.sub(r'\s{2,}', ' ', s)
+    # and finally remove leading/trailing whitespace
+    s = s.strip()
+    return s
+
+
+class TextIndex (object):
+    def __init__(self, history, cache_path):
+        self.history = history
+        self.log = history.log
+        
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+        
+        self._recorded_filename = os.path.join(cache_path, 'textindex-recorded')
+        self._index_filename = os.path.join(cache_path, 'textindex')
+        
+        # use a lockfile since the cache folder could be shared across different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
+        self._closed = False
+        
+        self.log.info('Using search index; %d entries.', len(self))
+    
+    def _is_indexed(self, revid, recorded):
+        return recorded.get(util.to_utf8(revid), None) is not None
+        
+    @with_lock
+    def is_indexed(self, revid):
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
+        try:
+            return self._is_indexed(revid, recorded)
+        finally:
+            recorded.close()
+    
+    @with_lock
+    def __len__(self):
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
+        try:
+            return len(recorded)
+        finally:
+            recorded.close()
+
+    @with_lock
+    def close(self):
+        self._closed = True
+    
+    @with_lock
+    def closed(self):
+        return self._closed
+    
+    @with_lock
+    def flush(self):
+        pass
+    
+    @with_lock
+    def full(self):
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
+        try:
+            return (len(recorded) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in recorded)
+        finally:
+            recorded.close()
+
+    def _index_change(self, change, recorded, index):
+        """
+        currently, only indexes the 'comment' field.
+        """
+        comment = normalize_string(change.comment)
+        if len(comment) < 3:
+            return
+        for i in xrange(len(comment) - 2):
+            sub = comment[i:i + 3]
+            revid_set = index.get(sub, None)
+            if revid_set is None:
+                revid_set = set()
+            elif revid_set == ALL:
+                # this entry got too big
+                continue
+            revid_set.add(change.revid)
+            if len(revid_set) > ALL_THRESHOLD:
+                revid_set = ALL
+            index[sub] = revid_set
+        
+        recorded[util.to_utf8(change.revid)] = True
+
+    @with_lock
+    def index_changes(self, revid_list):
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
+        index = shelve.open(self._index_filename, 'c', protocol=2)
+        try:
+            revid_list = [r for r in revid_list if not self._is_indexed(r, recorded)]
+            change_list = self.history.get_changes(revid_list)
+            for change in change_list:
+                self._index_change(change, recorded, index)
+        finally:
+            index.close()
+            recorded.close()
+    
+    @with_lock
+    def find(self, text, revid_list=None):
+        index = shelve.open(self._index_filename, 'c', protocol=2)
+        try:
+            text = normalize_string(text)
+            if len(text) < 3:
+                return []
+    
+            total_set = None
+            if revid_list is not None:
+                total_set = set(revid_list)
+            seen_all = False
+            
+            for i in xrange(len(text) - 2):
+                sub = text[i:i + 3]
+                revid_set = index.get(sub, None)
+                if revid_set is None:
+                    # zero matches, stop here.
+                    return []
+                if revid_set == ALL:
+                    # skip
+                    seen_all = True
+                    continue
+                if total_set is None:
+                    total_set = revid_set
+                else:
+                    total_set.intersection_update(revid_set)
+                if len(total_set) == 0:
+                    return []
+        finally:
+            index.close()
+        
+        # tricky: if seen_all is True, one of the substring indices was ALL
+        # (in other words, unindexed), so our results are actually a superset
+        # of the exact answer.
+        #
+        # if we cared, we could do a direct match on the result set and cull
+        # out any that aren't actually matches.  for now, i'm gonna say that
+        # we DON'T care, and if one of the substrings hit ALL, there's a small
+        # chance that we'll give a few false positives.
+        return total_set
+    
+    def check_rebuild(self, max_time=3600):
+        """
+        check if there are any un-indexed revisions, and if so, index them.
+        but don't spend longer than C{max_time} on it.
+        """
+        if self.closed() or self.full():
+            # all done
+            return
+
+        self.log.info('Building search index...')
+        work = list(self.history.get_revision_history())
+        start_time = time.time()
+        last_update = time.time()
+        count = 0
+
+        jump = 100
+        for i in xrange(0, len(work), jump):
+            r = work[i:i + jump]
+            self.index_changes(r)
+            if self.closed():
+                return
+
+            count += jump
+            now = time.time()
+            if now - start_time > 3600:
+                # there's no point working for hours.  eventually we might even
+                # hit the next re-index interval, which would suck mightily.
+                self.log.info('Search indexing has worked for an hour; giving up for now.')
+                return
+            if now - last_update > 60:
+                self.log.info('Search indexing continues: %d/%d' % (min(count, len(work)), len(work)))
+                last_update = time.time()
+            # give someone else a chance at the lock
+            time.sleep(1)
+        self.log.info('Search index completed.')
+        self.flush()
+

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-15 09:20:04 +0000
+++ loggerhead/util.py	2007-01-21 00:05:52 +0000
@@ -17,12 +17,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import base64
 import cgi
 import datetime
 import logging
 import re
 import sha
+import struct
+import sys
 import threading
+import traceback
 
 import turbogears
 
@@ -63,7 +67,15 @@
 def ago(timestamp):
     now = datetime.datetime.now()
     return timespan(now - timestamp) + ' ago'
-    
+
+
+def fix_year(year):
+    if year < 70:
+        year += 2000
+    if year < 100:
+        year += 1900
+    return year
+
 
 class Container (object):
     """
@@ -102,6 +114,12 @@
     return text[:limit] + '...'
 
 
+def to_utf8(s):
+    if isinstance(s, unicode):
+        return s.encode('utf-8')
+    return s
+
+
 STANDARD_PATTERN = re.compile(r'^(.*?)\s*<(.*?)>\s*$')
 EMAIL_PATTERN = re.compile(r'[-\w\d\+_!%\.]+@[-\w\d\+_!%\.]+')
 
@@ -159,13 +177,18 @@
             out.insert(0, -n)
 
 
+# only do this if unicode turns out to be a problem
+#_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
+
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
     entities, and replace spaces with '&nbsp;'.  this is primarily for use
     in displaying monospace text.
     """
-    s = cgi.escape(s.expandtabs()).replace(' ', '&nbsp;')
+    s = cgi.escape(s.expandtabs())
+#    s = _BADCHARS_RE.sub(lambda x: '&#%d;' % (ord(x.group(0)),), s)
+    s = s.replace(' ', '&nbsp;')
     return s
 
 
@@ -187,59 +210,195 @@
     return format % value
 
 
+def b64(s):
+    s = base64.encodestring(s).replace('\n', '')
+    while (len(s) > 0) and (s[-1] == '='):
+        s = s[:-1]
+    return s
+
+
+def uniq(uniqs, s):
+    """
+    turn a potentially long string into a unique smaller string.
+    """
+    if s in uniqs:
+        return uniqs[s]
+    uniqs[type(None)] = next = uniqs.get(type(None), 0) + 1
+    x = struct.pack('>I', next)
+    while (len(x) > 1) and (x[0] == '\x00'):
+        x = x[1:]
+    uniqs[s] = b64(x)
+    return uniqs[s]
+
+
+KILO = 1024
+MEG = 1024 * KILO
+GIG = 1024 * MEG
+P95_MEG = int(0.9 * MEG)
+P95_GIG = int(0.9 * GIG)
+
+def human_size(size, min_divisor=0):
+    size = int(size)
+    if (size == 0) and (min_divisor == 0):
+        return '0'
+    if (size < 512) and (min_divisor == 0):
+        return str(size)
+
+    if (size >= P95_GIG) or (min_divisor >= GIG):
+        divisor = GIG
+    elif (size >= P95_MEG) or (min_divisor >= MEG):
+        divisor = MEG
+    else:
+        divisor = KILO
+    
+    dot = size % divisor
+    base = size - dot
+    dot = dot * 10 // divisor
+    base //= divisor
+    if dot >= 10:
+        base += 1
+        dot -= 10
+    
+    out = str(base)
+    if (base < 100) and (dot != 0):
+        out += '.%d' % (dot,)
+    if divisor == KILO:
+        out += 'K'
+    elif divisor == MEG:
+        out += 'M'
+    elif divisor == GIG:
+        out += 'G'
+    return out
+    
+
 def fill_in_navigation(history, navigation):
     """
     given a navigation block (used by the template for the page header), fill
     in useful calculated values.
     """
-    navigation.position = history.get_revid_sequence(navigation.revlist, navigation.revid)
-    navigation.count = len(navigation.revlist)
+    navigation.position = history.get_revid_sequence(navigation.revid_list, navigation.revid)
+    if navigation.position is None:
+        navigation.position = 0
+    navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
-    navigation.page_count = (len(navigation.revlist) + (navigation.pagesize - 1)) // navigation.pagesize
+    navigation.page_count = (len(navigation.revid_list) + (navigation.pagesize - 1)) // navigation.pagesize
     
     def get_offset(offset):
-        if (navigation.position + offset < 0) or (navigation.position > navigation.count - 1):
+        if (navigation.position + offset < 0) or (navigation.position + offset > navigation.count - 1):
             return None
-        return navigation.revlist[navigation.position + offset]
+        return navigation.revid_list[navigation.position + offset]
     
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
+    
+    params = { 'file_id': navigation.file_id }
+    if getattr(navigation, 'query', None) is not None:
+        params['q'] = navigation.query
+    else:
+        params['start_revid'] = navigation.start_revid
+        
     if navigation.prev_page_revid:
-        navigation.prev_page_url = turbogears.url([ navigation.scan_url, navigation.prev_page_revid ], path=navigation.path, start_revid=navigation.start_revid)
+        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
     if navigation.next_page_revid:
-        navigation.next_page_url = turbogears.url([ navigation.scan_url, navigation.next_page_revid ], path=navigation.path, start_revid=navigation.start_revid)
-
-
-# global branch history & cache
-
-_history = None
-_history_lock = threading.Lock()
-
-def get_history():
-    global _history
-    from loggerhead.history import History
-    
-    config = get_config()
-    
-    _history_lock.acquire()
-    try:
-        if (_history is None) or _history.out_of_date():
-            log.debug('Reload branch history...')
-            if _history is not None:
-                _history.dont_use_cache()
-            _history = History.from_folder(config.get('folder'))
-            _history.use_cache(config.get('cachepath'))
-        return _history
-    finally:
-        _history_lock.release()
-
-
-_config = None
-
-def set_config(config):
-    global _config
-    _config = config
-
-def get_config():
-    return _config
-
+        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **get_context(**params))
+
+
+def log_exception(log):
+    for line in ''.join(traceback.format_exception(*sys.exc_info())).split('\n'):
+        log.debug(line)
+
+
+def decorator(unbound):
+    def new_decorator(f):
+        g = unbound(f)
+        g.__name__ = f.__name__
+        g.__doc__ = f.__doc__
+        g.__dict__.update(f.__dict__)
+        return g
+    new_decorator.__name__ = unbound.__name__
+    new_decorator.__doc__ = unbound.__doc__
+    new_decorator.__dict__.update(unbound.__dict__)
+    return new_decorator
+
+
+# common threading-lock decorator
+def with_lock(lockname, debug_name=None):
+    if debug_name is None:
+        debug_name = lockname
+    @decorator
+    def _decorator(unbound):
+        def locked(self, *args, **kw):
+            getattr(self, lockname).acquire()
+            try:
+                return unbound(self, *args, **kw)
+            finally:
+                getattr(self, lockname).release()
+        return locked
+    return _decorator
+
+
+@decorator
+def strip_whitespace(f):
+    def _f(*a, **kw):
+        out = f(*a, **kw)
+        orig_len = len(out)
+        out = re.sub(r'\n\s+', '\n', out)
+        out = re.sub(r'[ \t]+', ' ', out)
+        out = re.sub(r'\s+\n', '\n', out)
+        new_len = len(out)
+        log.debug('Saved %sB (%d%%) by stripping whitespace.',
+                  human_size(orig_len - new_len),
+                  round(100.0 - float(new_len) * 100.0 / float(orig_len)))
+        return out
+    return _f
+
+
+# just thinking out loud here...
+#
+# so, when browsing around, there are 5 pieces of context, most optional:
+#     - current revid
+#         current location along the navigation path (while browsing)
+#     - starting revid (start_revid)
+#         the current beginning of navigation (navigation continues back to
+#         the original revision) -- this may not be along the primary revision
+#         path since the user may have navigated into a branch
+#     - file_id
+#         if navigating the revisions that touched a file
+#     - q (query)
+#         if navigating the revisions that matched a search query
+#     - remember
+#         a previous revision to remember for future comparisons
+#
+# current revid is given on the url path.  the rest are optional components
+# in the url params.
+#
+# other transient things can be set:
+#     - compare_revid
+#         to compare one revision to another, on /revision only
+#     - sort
+#         for re-ordering an existing page by different sort
+
+t_context = threading.local()
+_valid = ('start_revid', 'file_id', 'q', 'remember', 'compare_revid', 'sort')
+
+
+def set_context(map):
+    t_context.map = dict((k, v) for (k, v) in map.iteritems() if k in _valid)
+
+
+def get_context(**overrides):
+    """
+    return a context map that may be overriden by specific values passed in,
+    but only contains keys from the list of valid context keys.
+    
+    if 'clear' is set, only the 'remember' context value will be added, and
+    all other context will be omitted.
+    """
+    map = dict()
+    if overrides.get('clear', False):
+        map['remember'] = t_context.map.get('remember', None)
+    else:
+        map.update(t_context.map)
+    overrides = dict((k, v) for (k, v) in overrides.iteritems() if k in _valid)
+    map.update(overrides)
+    return map

=== added file 'push-website'
--- push-website	1970-01-01 00:00:00 +0000
+++ push-website	2007-01-24 18:43:51 +0000
@@ -0,0 +1,7 @@
+#!/bin/bash
+#
+# this is only useful for robey.  it updates the public website.
+#
+
+rsync -avr homepage/ robey@green.lag.net:/web/loggerhead
+

=== removed file 'sample-prod.cfg'
--- sample-prod.cfg	2006-12-11 06:44:19 +0000
+++ sample-prod.cfg	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-[global]
-# This is where all of your settings go for your production environment.
-# You'll copy this file over to your production server and provide it
-# as a command-line option to your start script.
-# Settings that are the same for both development and production
-# (such as template engine, encodings, etc.) all go in 
-# loggerhead/config/app.cfg
-
-# pick the form for your database
-# sqlobject.dburi="postgres://username@hostname/databasename"
-# sqlobject.dburi="mysql://username:password@hostname:port/databasename"
-# sqlobject.dburi="sqlite:///file_name_and_path"
-
-# If you have sqlite, here's a simple default to get you started
-# in development
-sqlobject.dburi="sqlite://%(current_dir_uri)s/devdata.sqlite"
-
-
-# if you are using a database or table type without transactions
-# (MySQL default, for example), you should turn off transactions
-# by prepending notrans_ on the uri
-# sqlobject.dburi="notrans_mysql://username:password@hostname:port/databasename"
-
-# for Windows users, sqlite URIs look like:
-# sqlobject.dburi="sqlite:///drive_letter:/path/to/file"
-
-
-# SERVER
-
-server.environment="production"
-
-# Sets the number of threads the server uses
-# server.thread_pool = 1
-
-# if this is part of a larger site, you can set the path
-# to the TurboGears instance here
-# server.webpath=""
-
-# session_filter.on = True
-
-# Set to True if you'd like to abort execution if a controller gets an
-# unexpected parameter. False by default
-# tg.strict_parameters = False
-
-# LOGGING
-# Logging configuration generally follows the style of the standard
-# Python logging module configuration. Note that when specifying
-# log format messages, you need to use *() for formatting variables.
-# Deployment independent log configuration is in loggerhead/config/log.cfg
-[logging]
-
-[[handlers]]
-
-[[[access_out]]]
-# set the filename as the first argument below
-args="('server.log',)"
-class='FileHandler'
-level='INFO'
-formatter='message_only'
-
-[[loggers]]
-[[[loggerhead]]]
-level='ERROR'
-qualname='loggerhead'
-handlers=['error_out']
-
-[[[access]]]
-level='INFO'
-qualname='turbogears.access'
-handlers=['access_out']
-propagate=0

=== modified file 'setup.py'
--- setup.py	2006-12-11 06:44:19 +0000
+++ setup.py	2006-12-23 19:29:05 +0000
@@ -4,58 +4,37 @@
 import os
 execfile(os.path.join("loggerhead", "release.py"))
 
+
 setup(
     name="loggerhead",
     version=version,
     
-    # uncomment the following lines if you fill them out in release.py
-    #description=description,
-    #author=author,
-    #author_email=email,
-    #url=url,
-    #download_url=download_url,
-    #license=license,
+    description=description,
+    author=author,
+    author_email=email,
+    url=url,
+    download_url=download_url,
+    license=license,
     
     install_requires = [
         "TurboGears >= 1.0b1",
+        "bzr >= 0.13",
     ],
     scripts = ["start-loggerhead.py"],
     zip_safe=False,
     packages=find_packages(),
     package_data = find_package_data(where='loggerhead',
                                      package='loggerhead'),
+    data_files = find_package_data(where='loggerhead', package='loggerhead'),
     keywords = [
-        # Use keywords if you'll be adding your package to the
-        # Python Cheeseshop
-        
-        # if this has widgets, uncomment the next line
-        # 'turbogears.widgets',
-        
-        # if this has a tg-admin command, uncomment the next line
-        # 'turbogears.command',
-        
-        # if this has identity providers, uncomment the next line
-        # 'turbogears.identity.provider',
-    
-        # If this is a template plugin, uncomment the next line
-        # 'python.templating.engines',
-        
-        # If this is a full application, uncomment the next line
-        # 'turbogears.app',
+        'turbogears.app',
     ],
     classifiers = [
         'Development Status :: 3 - Alpha',
         'Operating System :: OS Independent',
         'Programming Language :: Python',
-        'Topic :: Software Development :: Libraries :: Python Modules',
         'Framework :: TurboGears',
-        # if this is an application that you'll distribute through
-        # the Cheeseshop, uncomment the next line
-        # 'Framework :: TurboGears :: Applications',
-        
-        # if this is a package that includes widgets that you'll distribute
-        # through the Cheeseshop, uncomment the next line
-        # 'Framework :: TurboGears :: Widgets',
+        'Framework :: TurboGears :: Applications',
     ],
     test_suite = 'nose.collector',
     )

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2006-12-15 10:05:25 +0000
+++ start-loggerhead.py	2007-01-16 03:53:02 +0000
@@ -1,28 +1,102 @@
 #!/usr/bin/env python2.4
+
 import pkg_resources
 pkg_resources.require("TurboGears")
 
+import logging
+import os
+
 import turbogears
 import cherrypy
 cherrypy.lowercase_api = True
 
-from os.path import *
 import sys
 
-# first look on the command line for a desired config file,
-# if it's not on the command line, then
-# look for setup.py in this directory. If it's not there, this script is
-# probably installed
+
+def setup_logging(home, foreground):
+    # i hate that stupid logging config format, so just set up logging here.
+
+    log_folder = os.path.join(home, 'logs')
+    if not os.path.exists(log_folder):
+        os.mkdir(log_folder)
+    
+    f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
+                          '%Y%m%d-%H:%M:%S')
+    debug_log = logging.FileHandler(os.path.join(log_folder, 'debug.log'))
+    debug_log.setLevel(logging.DEBUG)
+    debug_log.setFormatter(f)
+    if foreground:
+        stdout_log = logging.StreamHandler(sys.stdout)
+        stdout_log.setLevel(logging.DEBUG)
+        stdout_log.setFormatter(f)
+    f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
+                          '%Y%m%d-%H:%M:%S')
+    access_log = logging.FileHandler(os.path.join(log_folder, 'access.log'))
+    access_log.setLevel(logging.INFO)
+    access_log.setFormatter(f)
+    
+    logging.getLogger('').addHandler(debug_log)
+    logging.getLogger('turbogears.access').addHandler(access_log)
+    logging.getLogger('turbogears.controllers').setLevel(logging.INFO)
+    
+    if foreground:
+        logging.getLogger('').addHandler(stdout_log)
+    
+
+
+foreground = False
 if len(sys.argv) > 1:
-    turbogears.update_config(configfile=sys.argv[1], 
-        modulename="loggerhead.config")
-elif exists(join(dirname(__file__), "setup.py")):
-    turbogears.update_config(configfile="dev.cfg",
-        modulename="loggerhead.config")
-else:
-    turbogears.update_config(configfile="prod.cfg",
-        modulename="loggerhead.config")
+    if sys.argv[1] == '-f':
+        foreground = True
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+# read loggerhead config
+
+from configobj import ConfigObj
+config = sys._loggerhead_config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+extra_path = config.get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
+
+turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
+for key, keytype in potential_overrides:
+    value = config.get(key, None)
+    if value is not None:
+        value = keytype(value)
+        turbogears.config.update({ key: value })
+
+if not foreground:
+    sys.stderr.write('\n')
+    sys.stderr.write('Launching loggerhead into the background.\n')
+    sys.stderr.write('PID file: %s\n' % (pidfile,))
+    sys.stderr.write('\n')
+
+    from loggerhead.daemon import daemonize
+    daemonize(pidfile, home)
+
+setup_logging(home, foreground=foreground)
+    
+log = logging.getLogger('loggerhead')
+log.info('Starting up...')
 
 from loggerhead.controllers import Root
 
-turbogears.start_server(Root())
+# re-index every 6 hours
+
+index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
+turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
+
+try:
+    turbogears.start_server(Root)
+finally:
+    log.info('Shutdown.')
+    try:
+        os.remove(pidfile)
+    except OSError:
+        pass
+
+

=== added file 'stop-loggerhead.py'
--- stop-loggerhead.py	1970-01-01 00:00:00 +0000
+++ stop-loggerhead.py	2007-01-24 19:17:25 +0000
@@ -0,0 +1,31 @@
+#!/usr/bin/env python2.4
+
+import pkg_resources
+pkg_resources.require("TurboGears")
+
+import os
+import sys
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+try:
+    f = open(pidfile, 'r')
+except IOError, e:
+    print 'No pid file found.'
+    sys.exit(1)
+
+pid = int(f.readline())
+
+try:
+    os.kill(pid, 0)
+except OSError, e:
+    print 'Stale pid file; server is not running.'
+    sys.exit(1)
+
+print
+print 'Shutting down previous server @ pid %d.' % (pid,)
+print
+
+import signal
+os.kill(pid, signal.SIGINT)

